GNU logs - #5570, boring messages


Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: "Bob" <purchasebyemail1@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 12 Feb 2010 22:53:01 +0000
Resent-Message-ID: <handler.5570.B.126601515023650 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: report 5570
X-Emacs-PR-Package: emacs
X-Emacs-PR-Keywords: 
To: 5570 <at> debbugs.gnu.org
X-Debbugs-Original-To: "'Emacs bug Tracking System'" <bug-gnu-emacs@HIDDEN>
Received: via spool by submit <at> debbugs.gnu.org id=B.126601515023650
          (code B ref -1); Fri, 12 Feb 2010 22:53:01 +0000
Received: (at submit) by debbugs.gnu.org; 12 Feb 2010 22:52:30 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ng4NC-00069P-6m
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2010 17:52:30 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Ng4NA-00069H-Ka
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2010 17:52:28 -0500
Received: from mx10.gnu.org ([199.232.76.166]:56975)
	by fencepost.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Ng4N9-00045j-3R
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2010 17:52:27 -0500
Received: from Debian-exim by monty-python.gnu.org with spam-scanned (Exim
	4.60) (envelope-from <purchasebyemail1@HIDDEN>)
	id 1Ng4N7-0008VB-91
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2010 17:52:26 -0500
X-Spam-Checker-Version: SpamAssassin 3.1.0 (2005-09-13) on monty-python
X-Spam-Level: 
X-Spam-Status: No, score=-2.4 required=5.0 tests=AWL,BAYES_00,HTML_MESSAGE,
	UNPARSEABLE_RELAY autolearn=ham version=3.1.0
Received: from lists.gnu.org ([199.232.76.165]:48032)
	by monty-python.gnu.org with esmtps
	(TLS-1.0:DHE_RSA_AES_256_CBC_SHA1:32) (Exim 4.60)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Ng4N7-0008V7-3t
	for submit <at> debbugs.gnu.org; Fri, 12 Feb 2010 17:52:25 -0500
Received: from mailman by lists.gnu.org with tmda-scanned (Exim 4.43)
	id 1Ng4N6-0007jM-Kg
	for bug-gnu-emacs@HIDDEN; Fri, 12 Feb 2010 17:52:24 -0500
Received: from [140.186.70.92] (port=43371 helo=eggs.gnu.org)
	by lists.gnu.org with esmtp (Exim 4.43) id 1Ng4N6-0007jE-2y
	for bug-gnu-emacs@HIDDEN; Fri, 12 Feb 2010 17:52:24 -0500
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Ng4N5-0002c7-Ek
	for bug-gnu-emacs@HIDDEN; Fri, 12 Feb 2010 17:52:23 -0500
Received: from qmta01.emeryville.ca.mail.comcast.net ([76.96.30.16]:46321)
	by eggs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Ng4N5-0002c1-2X
	for bug-gnu-emacs@HIDDEN; Fri, 12 Feb 2010 17:52:23 -0500
Received: from omta20.emeryville.ca.mail.comcast.net ([76.96.30.87])
	by qmta01.emeryville.ca.mail.comcast.net with comcast
	id h8XM1d0021smiN4A1AsL4n; Fri, 12 Feb 2010 22:52:20 +0000
Received: from Cache ([71.202.16.94])
	by omta20.emeryville.ca.mail.comcast.net with comcast
	id hAsK1d00321mHQP8gAsKsM; Fri, 12 Feb 2010 22:52:19 +0000
From: "Bob" <purchasebyemail1@HIDDEN>
Date: Fri, 12 Feb 2010 14:52:31 -0800
Message-ID: <000301caac36$0fc0b760$2f422620$@net>
MIME-Version: 1.0
Content-Type: multipart/alternative;
	boundary="----=_NextPart_000_0004_01CAABF3.019D7760"
X-Mailer: Microsoft Office Outlook 12.0
Thread-Index: AcqsNg8ZkRNqaHRpTr6xx6bbdf3w0w==
Content-Language: en-us
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by monty-python.gnu.org: GNU/Linux 2.6,
	seldom 2.4 (older, 4)
X-Spam-Score: -4.6 (----)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -4.3 (----)

This is a multi-part message in MIME format.

------=_NextPart_000_0004_01CAABF3.019D7760
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit

As I work with text in C++ mode the indentation begins to deteriorate. For
example, TAB on the class line wrongly indents it:

 

    template<class _Enum>

      class Build<TL::End,_Enum>

 

I work-around the problem by writing the buffer, killing the buffer, then
visiting the file and re-indenting with TAB on the class line to get the
expected indentation:

 

    template<class _Enum>

    class Build<TL::End,_Enum>

 

Same thing happens with ESC C-q.

 

My impression is there is internal state which doesn't get cleared as I work
the text toward a syntax correct unit, causing incorrect indentation.  The
bad state is ultimately cleared by re-visiting the file. 

 

Sorry I can't come up with something reproducible.  

 

Has anyone else seen this issue?

 

 

      


------=_NextPart_000_0004_01CAABF3.019D7760
Content-Type: text/html;
	charset="us-ascii"
Content-Transfer-Encoding: quoted-printable

<html xmlns:v=3D"urn:schemas-microsoft-com:vml" =
xmlns:o=3D"urn:schemas-microsoft-com:office:office" =
xmlns:w=3D"urn:schemas-microsoft-com:office:word" =
xmlns:m=3D"http://schemas.microsoft.com/office/2004/12/omml" =
xmlns=3D"http://www.w3.org/TR/REC-html40">

<head>
<meta http-equiv=3DContent-Type content=3D"text/html; =
charset=3Dus-ascii">
<meta name=3DGenerator content=3D"Microsoft Word 12 (filtered medium)">
<style>
<!--
 /* Font Definitions */
 @font-face
	{font-family:"Cambria Math";
	panose-1:2 4 5 3 5 4 6 3 2 4;}
@font-face
	{font-family:Calibri;
	panose-1:2 15 5 2 2 2 4 3 2 4;}
 /* Style Definitions */
 p.MsoNormal, li.MsoNormal, div.MsoNormal
	{margin:0in;
	margin-bottom:.0001pt;
	font-size:11.0pt;
	font-family:"Calibri","sans-serif";}
a:link, span.MsoHyperlink
	{mso-style-priority:99;
	color:blue;
	text-decoration:underline;}
a:visited, span.MsoHyperlinkFollowed
	{mso-style-priority:99;
	color:purple;
	text-decoration:underline;}
span.EmailStyle17
	{mso-style-type:personal-compose;
	font-family:"Calibri","sans-serif";
	color:windowtext;}
.MsoChpDefault
	{mso-style-type:export-only;}
@page Section1
	{size:8.5in 11.0in;
	margin:1.0in 1.0in 1.0in 1.0in;}
div.Section1
	{page:Section1;}
-->
</style>
<!--[if gte mso 9]><xml>
 <o:shapedefaults v:ext=3D"edit" spidmax=3D"1026" />
</xml><![endif]--><!--[if gte mso 9]><xml>
 <o:shapelayout v:ext=3D"edit">
  <o:idmap v:ext=3D"edit" data=3D"1" />
 </o:shapelayout></xml><![endif]-->
</head>

<body lang=3DEN-US link=3Dblue vlink=3Dpurple>

<div class=3DSection1>

<p class=3DMsoNormal>As I work with text in C++ mode the indentation =
begins to
deteriorate. For example, TAB on the class line wrongly indents =
it:<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>&nbsp;&nbsp;&nbsp; template&lt;class =
_Enum&gt;<o:p></o:p></p>

<p class=3DMsoNormal>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; class
Build&lt;TL::End,_Enum&gt;<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>I work-around the problem by writing the buffer, =
killing the
buffer, then visiting the file and re-indenting with TAB on the class =
line to
get the expected indentation:<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>&nbsp;&nbsp;&nbsp; template&lt;class =
_Enum&gt;<o:p></o:p></p>

<p class=3DMsoNormal>&nbsp;&nbsp;&nbsp; class =
Build&lt;TL::End,_Enum&gt;<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>Same thing happens with ESC C-q.<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>My impression is there is internal state which =
doesn't get
cleared as I work the text toward a syntax correct unit, causing =
incorrect
indentation.&nbsp; The bad state is ultimately cleared by re-visiting =
the file.
<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>Sorry I can't come up with something reproducible. =
&nbsp;<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>Has anyone else seen this issue?<o:p></o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal><o:p>&nbsp;</o:p></p>

<p class=3DMsoNormal>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <o:p></o:p></p>

</div>

</body>

</html>

------=_NextPart_000_0004_01CAABF3.019D7760--






Message sent:


Content-Disposition: inline
Content-Transfer-Encoding: quoted-printable
MIME-Version: 1.0
X-Mailer: MIME-tools 5.427 (Entity 5.427)
Content-Type: text/plain; charset=utf-8
X-Loop: bug-gnu-emacs@HIDDEN
From: bug-gnu-emacs@HIDDEN (Emacs bug Tracking System)
To: "Bob" <purchasebyemail1@HIDDEN>
Subject: bug#5570: Acknowledgement (Emacs 23.1.91.1 C++ mode "ESC C-q" and
 TAB indenting issue.)
Message-ID: <handler.5570.B.126601515023650.ack <at> debbugs.gnu.org>
References: <000301caac36$0fc0b760$2f422620$@net>
X-Emacs-PR-Message: ack 5570
X-Emacs-PR-Package: emacs
Reply-To: 5570 <at> debbugs.gnu.org
Date: Fri, 12 Feb 2010 22:53:02 +0000

Thank you for filing a new bug report with Emacs.

This is an automatically generated reply to let you know your message
has been received.

Your message is being forwarded to the package maintainers and other
interested parties for their attention; they will reply in due course.

Your message has been sent to the package maintainer(s):
 bug-gnu-emacs@HIDDEN

If you wish to submit further information on this problem, please
send it to 5570 <at> debbugs.gnu.org.

Please do not send mail to bug-gnu-emacs@HIDDEN unless you wish
to report a problem with the Bug-tracking system.

--=20
5570: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=3D5570
Emacs Bug Tracking System
Contact bug-gnu-emacs@HIDDEN with problems


Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sat, 13 Feb 2010 07:38:02 +0000
Resent-Message-ID: <handler.5570.B5570.126604666914071 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs
X-Emacs-PR-Keywords: 
To: Alan Mackenzie  <acm@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org, Bob <purchasebyemail1@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126604666914071
          (code B ref 5570); Sat, 13 Feb 2010 07:38:02 +0000
Received: (at 5570) by debbugs.gnu.org; 13 Feb 2010 07:37:49 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NgCZZ-0003et-0o
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2010 02:37:49 -0500
Received: from pantheon-po35.its.yale.edu ([130.132.50.83])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1NgCZX-0003el-HL
	for 5570 <at> debbugs.gnu.org; Sat, 13 Feb 2010 02:37:48 -0500
Received: from furry (bb121-6-236-4.singnet.com.sg [121.6.236.4])
	(authenticated bits=0)
	by pantheon-po35.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o1D7bh3O013371
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Sat, 13 Feb 2010 02:37:45 -0500
Received: by furry (Postfix, from userid 1000)
	id 2EB64C05D; Sat, 13 Feb 2010 02:37:42 -0500 (EST)
From: Chong Yidong <cyd@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
Date: Sat, 13 Feb 2010 02:37:42 -0500
In-Reply-To: <000301caac36$0fc0b760$2f422620$@net> (Bob's message of "Fri, 12
	Feb 2010 14:52:31 -0800")
Message-ID: <87pr494md5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/23.1.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -2.6 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Hi Alan,

Looks like this is related to Bug#5490.  WDYT?


"Bob" <purchasebyemail1@HIDDEN> writes:

> As I work with text in C++ mode the indentation begins to deteriorate. For
> example, TAB on the class line wrongly indents it:
>
>     template<class _Enum>
>       class Build<TL::End,_Enum>
>
> I work-around the problem by writing the buffer, killing the buffer, then
> visiting the file and re-indenting with TAB on the class line to get the
> expected indentation:
>
>     template<class _Enum>
>     class Build<TL::End,_Enum>
>
> Same thing happens with ESC C-q.
>
> My impression is there is internal state which doesn't get cleared as I work
> the text toward a syntax correct unit, causing incorrect indentation.  The bad
> state is ultimately cleared by re-visiting the file.
>
> Sorry I can't come up with something reproducible.
>
> Has anyone else seen this issue?




Message received at control <at> debbugs.gnu.org:


Received: (at control) by debbugs.gnu.org; 13 Feb 2010 19:35:38 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Feb 13 14:35:37 2010
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NgNmD-0004MJ-IO
	for submit <at> debbugs.gnu.org; Sat, 13 Feb 2010 14:35:37 -0500
Received: from fencepost.gnu.org ([140.186.70.10])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <rgm@HIDDEN>) id 1NgNmB-0004M9-OJ
	for control <at> debbugs.gnu.org; Sat, 13 Feb 2010 14:35:35 -0500
Received: from rgm by fencepost.gnu.org with local (Exim 4.69)
	(envelope-from <rgm@HIDDEN>)
	id 1NgNm7-0005W3-H4; Sat, 13 Feb 2010 14:35:31 -0500
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Transfer-Encoding: 7bit
Message-ID: <19318.65283.455214.602312@HIDDEN>
Date: Sat, 13 Feb 2010 14:35:31 -0500
From: Glenn Morris <rgm@HIDDEN>
To: control <control <at> debbugs.gnu.org>
Subject: control
X-Spam-Score: -5.0 (-----)
X-Debbugs-Envelope-To: control
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -5.0 (-----)

tags 5547 moreinfo
close 5561
severity 5564 wishlist
severity 5566 minor
tags 5566 patch
reassign 5568 notemacs
severity 5569 serious
reassign 5570 emacs,cc-mode
severity 5572 minor
reassign 5573 emacs,gnus
merge 5574 5576
severity 5577 minor




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 14 Feb 2010 05:10:02 +0000
Resent-Message-ID: <handler.5570.B5570.126612418912910 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Alan Mackenzie  <acm@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org, Bob <purchasebyemail1@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126612418912910
          (code B ref 5570); Sun, 14 Feb 2010 05:10:02 +0000
Received: (at 5570) by debbugs.gnu.org; 14 Feb 2010 05:09:49 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NgWjt-0003MB-26
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2010 00:09:49 -0500
Received: from pantheon-po33.its.yale.edu ([130.132.50.94])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1NgWjq-0003M2-S1
	for 5570 <at> debbugs.gnu.org; Sun, 14 Feb 2010 00:09:47 -0500
Received: from furry (bb116-15-9-83.singnet.com.sg [116.15.9.83])
	(authenticated bits=0)
	by pantheon-po33.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o1E59eYn027019
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Sun, 14 Feb 2010 00:09:42 -0500
Received: by furry (Postfix, from userid 1000)
	id 63990C05D; Sun, 14 Feb 2010 00:09:39 -0500 (EST)
From: Chong Yidong <cyd@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<87pr494md5.fsf@HIDDEN>
	<000e01caad1e$dcbfc560$963f5020$@net>
Date: Sun, 14 Feb 2010 00:09:39 -0500
In-Reply-To: <000e01caad1e$dcbfc560$963f5020$@net> (Bob's message of "Sat, 13
	Feb 2010 18:38:58 -0800")
Message-ID: <876360s8rw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/23.1.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -2.6 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Forwarding an email with pertinent info to the bug tracker, and to Alan
the CC-mode maintainer:


"Bob" <purchasebyemail1@HIDDEN> writes:

> Yes, it does look related to 5490. I can respond to:
>
>> (i) Have you ever noticed this bug happening on earlier Emacsen, in
>>  particular Emacs 23.1?
>
> Yes, it happened in 23.1 also.
>
>> (ii) Does this bug happen every time you use Emacs this long, or only
>>  sometimes?
>
> For me it happens within minutes of use. My C++ files are HEAVILY templated
> and the issue appears to be related to '<' and '>' of template args, e.g.
>
> typedef IF<
>  MemberOf<a,b>::value,
>  IF<
>    Length<c,d>::value,
>    true,
>     false
>  >::Result,
>  false
>   >::Result  Result;
>
> I will have several of these, one after the other, and be editing
> them. By accident I'll leave out a ',' or a '>' or kill & yank lines
> with similar error. After minutes of such editing, the indentation
> gets wacked. Sometimes by TAB indentation on a prior line the problem
> corrects. Sometimes I have to write the buffer and re-visit it.
>
>>(iv) Are all C(++) buffers in this state, or only some?  Any correlation
>>  with how many edits have been done on a buffer, or how long it's been
>>  loaded?
>
> Just the buffer with the '<' and '>' in it.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 14 Feb 2010 20:04:01 +0000
Resent-Message-ID: <handler.5570.B5570.126617779424516 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org, Bob <purchasebyemail1@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126617779424516
          (code B ref 5570); Sun, 14 Feb 2010 20:04:01 +0000
Received: (at 5570) by debbugs.gnu.org; 14 Feb 2010 20:03:14 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NgkgT-0006NN-JZ
	for submit <at> debbugs.gnu.org; Sun, 14 Feb 2010 15:03:13 -0500
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NgkgE-0006Mt-Va
	for 5570 <at> debbugs.gnu.org; Sun, 14 Feb 2010 15:03:12 -0500
Received: (qmail 89538 invoked by uid 3782); 14 Feb 2010 20:02:53 -0000
Received: from acm.muc.de (pD9E52805.dip.t-dialin.net [217.229.40.5]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Sun, 14 Feb 2010 21:02:51 +0100
Received: (qmail 7107 invoked by uid 1000); 14 Feb 2010 20:10:06 -0000
Date: Sun, 14 Feb 2010 20:10:06 +0000
Message-ID: <20100214201006.GA6169@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<87pr494md5.fsf@HIDDEN>
	<000e01caad1e$dcbfc560$963f5020$@net>
	<876360s8rw.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <876360s8rw.fsf@HIDDEN>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.6 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Hi, Bob and Yidong,

On Sun, Feb 14, 2010 at 12:09:39AM -0500, Chong Yidong wrote:
> Forwarding an email with pertinent info to the bug tracker, and to Alan
> the CC-mode maintainer:


> "Bob" <purchasebyemail1@HIDDEN> writes:

> > Yes, it does look related to 5490. I can respond to:

I have the horrible suspicion that this is different from 5490.  :-(

> >> (i) Have you ever noticed this bug happening on earlier Emacsen, in
> >> particular Emacs 23.1?

> > Yes, it happened in 23.1 also.

> >> (ii) Does this bug happen every time you use Emacs this long, or
> >> only sometimes?

> > For me it happens within minutes of use. My C++ files are HEAVILY
> > templated and the issue appears to be related to '<' and '>' of
> > template args, e.g.

> > typedef IF<
> >  MemberOf<a,b>::value,
> >  IF<
> >    Length<c,d>::value,
> >    true,
> >     false
> >  >::Result,
> >  false
> >   >::Result  Result;

OK, template brackets are difficult, because they're so difficult to
distinguish from less/greater than.

Bob, seeing as how the bug hits you "withing minutes", is there any
chance you could try and get it reproducible?  Using a dribble file might
be useful (see the page "Checklist" in the Emacs manual; you'd use this
with something like '(open-dribble-file "~/dribble")' at the beginning of
your Emacs session).

If you manage to get it reproducible, could you send me the C++ file
(which I will regard as confidential if needed) together with the
sequence of commands (e.g. the dribble file) which triggers the bug.
Also appreciated would be a dump of your CC Mode configuration, generated
by C-c C-b.

> > I will have several of these, one after the other, and be editing
> > them. By accident I'll leave out a ',' or a '>' or kill & yank lines
> > with similar error. After minutes of such editing, the indentation
> > gets wacked. Sometimes by TAB indentation on a prior line the problem
> > corrects. Sometimes I have to write the buffer and re-visit it.

One other thing.  Would you please try M-: (c-state-cache-init) when in
this state, and tell me if it resolves the badness.  Thanks!

> >>(iv) Are all C(++) buffers in this state, or only some?  Any correlation
> >>  with how many edits have been done on a buffer, or how long it's been
> >>  loaded?

> > Just the buffer with the '<' and '>' in it.

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting	issue.
Resent-From: "Bob" <purchasebyemail1@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 15 Feb 2010 22:16:02 +0000
Resent-Message-ID: <handler.5570.B5570.12662721092465 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: "'Alan Mackenzie'" <acm@HIDDEN>, "'Chong Yidong'" <cyd@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12662721092465
          (code B ref 5570); Mon, 15 Feb 2010 22:16:02 +0000
Received: (at 5570) by debbugs.gnu.org; 15 Feb 2010 22:15:09 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Nh9Dg-0000di-Lf
	for submit <at> debbugs.gnu.org; Mon, 15 Feb 2010 17:15:09 -0500
Received: from qmta01.emeryville.ca.mail.comcast.net ([76.96.30.16])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Nh9De-0000d7-4h
	for 5570 <at> debbugs.gnu.org; Mon, 15 Feb 2010 17:15:07 -0500
Received: from omta19.emeryville.ca.mail.comcast.net ([76.96.30.76])
	by qmta01.emeryville.ca.mail.comcast.net with comcast
	id iMmC1d0021eYJf8A1NF2f3; Mon, 15 Feb 2010 22:15:02 +0000
Received: from Cache ([71.202.16.94])
	by omta19.emeryville.ca.mail.comcast.net with comcast
	id iNF11d00521mHQP01NF1wE; Mon, 15 Feb 2010 22:15:02 +0000
From: "Bob" <purchasebyemail1@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>	<87pr494md5.fsf@HIDDEN>	<000e01caad1e$dcbfc560$963f5020$@net>	<876360s8rw.fsf@HIDDEN>
	<20100214201006.GA6169@HIDDEN>
In-Reply-To: <20100214201006.GA6169@HIDDEN>
Date: Mon, 15 Feb 2010 14:15:21 -0800
Message-ID: <000301caae8c$5e161380$1a423a80$@net>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 12.0
Thread-Index: AcqtsLU823zvPRLrTS6AQucy6khbWAA2ZyPA
Content-Language: en-us
X-Spam-Score: -3.8 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.6 (---)

More stuff:

With the emacs I've had going since last week I have several buffers where
the
indentation is incorrect. I validate by writing the buffer, then in a fresh
emacs,
visit the file, go to the lines with incorrect indentation, apply TAB and
the
result is the correct indentation. Ok, nothing new there. 

This is new: After applying TAB in the 2nd emacs to correct the indentation
I write the file, then go back to the original buffer and re-visit the file
with "C-x C-f" "ESC-n".
Emacs confirms the file has changed, I reply "yes" and the visible buffer
becomes truncated
at the line where I TAB'ed to reformat:

The saved file is:

    template<
      class _TypeKind,
      class _EStore = typename ScalarVectorSelector<_TypeKind>::Result
      bool  _fixed  = TL::MemberOf<
	DataTypeTrait<GetDataType<_TypeKind>::Result>::TAbout,
	EnumDTP::FixedPacked
	>::value
      >

The re-visited buffer now shows:

    template<
      class _TypeKind,
      class _EStore = typename ScalarVectorSelector<_TypeKind>::Result
      bool  _fixed  = TL::MemberOf<
	   
EOF  <--------------- NO MORE TEXT!

The original incorrect indentation was something like this (it got lost when
I revisited):

    template<
      class _TypeKind,
      class _EStore = typename ScalarVectorSelector<_TypeKind>::Result
      bool  _fixed  = TL::MemberOf<
	        DataTypeTrait<GetDataType<_TypeKind>::Result>::TAbout,
	                      EnumDTP::FixedPacked
	                      >::value
              >

Now, I kill the truncated buffer, re-visit (the original emacs) and I see
correct indentation of the saved file, so I can continue work :) in the
original emacs.


-----Original Message-----
From: Alan Mackenzie [mailto:acm@HIDDEN] 
Sent: Sunday, February 14, 2010 12:10 PM
To: Chong Yidong
Cc: Bob; 5570 <at> debbugs.gnu.org
Subject: Re: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting
issue.

Hi, Bob and Yidong,

On Sun, Feb 14, 2010 at 12:09:39AM -0500, Chong Yidong wrote:
> Forwarding an email with pertinent info to the bug tracker, and to Alan
> the CC-mode maintainer:


> "Bob" <purchasebyemail1@HIDDEN> writes:

> > Yes, it does look related to 5490. I can respond to:

I have the horrible suspicion that this is different from 5490.  :-(

> >> (i) Have you ever noticed this bug happening on earlier Emacsen, in
> >> particular Emacs 23.1?

> > Yes, it happened in 23.1 also.

> >> (ii) Does this bug happen every time you use Emacs this long, or
> >> only sometimes?

> > For me it happens within minutes of use. My C++ files are HEAVILY
> > templated and the issue appears to be related to '<' and '>' of
> > template args, e.g.

> > typedef IF<
> >  MemberOf<a,b>::value,
> >  IF<
> >    Length<c,d>::value,
> >    true,
> >     false
> >  >::Result,
> >  false
> >   >::Result  Result;

OK, template brackets are difficult, because they're so difficult to
distinguish from less/greater than.

Bob, seeing as how the bug hits you "withing minutes", is there any
chance you could try and get it reproducible?  Using a dribble file might
be useful (see the page "Checklist" in the Emacs manual; you'd use this
with something like '(open-dribble-file "~/dribble")' at the beginning of
your Emacs session).

If you manage to get it reproducible, could you send me the C++ file
(which I will regard as confidential if needed) together with the
sequence of commands (e.g. the dribble file) which triggers the bug.
Also appreciated would be a dump of your CC Mode configuration, generated
by C-c C-b.

> > I will have several of these, one after the other, and be editing
> > them. By accident I'll leave out a ',' or a '>' or kill & yank lines
> > with similar error. After minutes of such editing, the indentation
> > gets wacked. Sometimes by TAB indentation on a prior line the problem
> > corrects. Sometimes I have to write the buffer and re-visit it.

One other thing.  Would you please try M-: (c-state-cache-init) when in
this state, and tell me if it resolves the badness.  Thanks!

> >>(iv) Are all C(++) buffers in this state, or only some?  Any correlation
> >>  with how many edits have been done on a buffer, or how long it's been
> >>  loaded?

> > Just the buffer with the '<' and '>' in it.

-- 
Alan Mackenzie (Nuremberg, Germany).





Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting	issue.
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 16 Feb 2010 16:33:02 +0000
Resent-Message-ID: <handler.5570.B5570.126633793823136 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Bob <purchasebyemail1@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126633793823136
          (code B ref 5570); Tue, 16 Feb 2010 16:33:02 +0000
Received: (at 5570) by debbugs.gnu.org; 16 Feb 2010 16:32:18 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NhQLS-000617-0K
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2010 11:32:18 -0500
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NhQLP-000610-72
	for 5570 <at> debbugs.gnu.org; Tue, 16 Feb 2010 11:32:16 -0500
Received: (qmail 71478 invoked by uid 3782); 16 Feb 2010 16:32:09 -0000
Received: from acm.muc.de (pD9E510DB.dip.t-dialin.net [217.229.16.219]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Tue, 16 Feb 2010 17:32:07 +0100
Received: (qmail 16512 invoked by uid 1000); 16 Feb 2010 16:39:24 -0000
Date: Tue, 16 Feb 2010 16:39:24 +0000
Message-ID: <20100216163923.GB3456@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<87pr494md5.fsf@HIDDEN>
	<000e01caad1e$dcbfc560$963f5020$@net>
	<876360s8rw.fsf@HIDDEN> <20100214201006.GA6169@HIDDEN>
	<000001caae62$638af6c0$2aa0e440$@net>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <000001caae62$638af6c0$2aa0e440$@net>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.6 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Hi, Bob,

On Mon, Feb 15, 2010 at 09:14:52AM -0800, Bob wrote:
> Alan,

> I am now running two emacs 23.1.91.1, one I started last week with many
> files open in which I "work" etc., and one I just started with dribbling
> "on" to edit a file I have seen the issue in. After half-hours editing in
> this one, nothing bad has happened. I temporarily jumped back to the "work"
> session to add a few needed lines and wammy! the problem appeared after
> adding 7 lines:

Could you be a little bit more exact in exactly what you did here.  I
have just fired up emacs 23.1.91, typed in 

    namespace foo
    {

(in column 0), then typed in the the lines that you've identified as
causing the error:

>   template<class _DataType>
>   struct SelectInternalConvertableToVectorType
>   {
>     typedef typename DataTypeTrait<_DataType>::TAbout	TAbout;
>
>     typedef TL::IF<TL::MemberOf<TAbout,EnumDTP::Internal>::value>
> TInternal;
>     typedef TL::IF<
> 	TL::MemberOf<TAbout,EnumDTP::HasVectorType>::value
> 	>					   TConvertableToVectorType;
> 	
>     typedef TL::IF<
>       (TInternal::value &&
> TConvertableToVectorType::value),_DataType,TL::False
>       >::Result						Result;
> };   <------------------------ Appears in column 1

However, that "};" for me appeared in the correct column, not in column
0.

> I wrote the buffer, started a 3rd emacs, went to the line, hit TAB and the
> indentation
> corrected:

That, at least, is refreshing.

>   };   <------------------------ Correct.

> Back in the original session TAB still places the '{' in column 1.

It doesn't for me.  But I _have_ seen this error happening.

So, could you please try and give me a precise recipe for how to
reproduce the error, down at the level of what the buffer should look
like before inserting these lines, and which keys to press to insert
them.  Was I correct in guessing that you typed in the lines when you
said you "added" them, as opposed to, say, C-y?

> I am now attempting to try your c-state-cache-init and find this is not
> defined.

That's exactly

    M-: (c-state-cache-init)

, including the parens round the word.  Are you certain you typed it
correctly?  It should be there in Emacs 23.1.91.

> Please advise what to do. I've attached "describe-bindings" if that helps. 

> Thanks,
> Bob

> PS "C-c C-b" runs "c-submit-bug-report" - is that what you expect?

Yes.  It produces a dump of CC Mode's config as part of a mail buffer.
Cut and paste it into your own mail client.

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB	indenting	issue.
Resent-From: "Bob" <purchasebyemail1@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 16 Feb 2010 18:36:01 +0000
Resent-Message-ID: <handler.5570.B5570.126634532128526 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: "'Alan Mackenzie'" <acm@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126634532128526
          (code B ref 5570); Tue, 16 Feb 2010 18:36:01 +0000
Received: (at 5570) by debbugs.gnu.org; 16 Feb 2010 18:35:21 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NhSGX-0007Q3-Ex
	for submit <at> debbugs.gnu.org; Tue, 16 Feb 2010 13:35:21 -0500
Received: from qmta11.emeryville.ca.mail.comcast.net ([76.96.27.211])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1NhSGV-0007Pw-SD
	for 5570 <at> debbugs.gnu.org; Tue, 16 Feb 2010 13:35:20 -0500
Received: from omta05.emeryville.ca.mail.comcast.net ([76.96.30.43])
	by qmta11.emeryville.ca.mail.comcast.net with comcast
	id ieM51d0050vp7WLABiYXpA; Tue, 16 Feb 2010 18:32:31 +0000
Received: from Cache ([71.202.16.94])
	by omta05.emeryville.ca.mail.comcast.net with comcast
	id iibE1d00C21mHQP8RibF3P; Tue, 16 Feb 2010 18:35:15 +0000
From: "Bob" <purchasebyemail1@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>	<87pr494md5.fsf@HIDDEN>	<000e01caad1e$dcbfc560$963f5020$@net>	<876360s8rw.fsf@HIDDEN>
	<20100214201006.GA6169@HIDDEN>	<000001caae62$638af6c0$2aa0e440$@net>
	<20100216163923.GB3456@HIDDEN>
In-Reply-To: <20100216163923.GB3456@HIDDEN>
Date: Tue, 16 Feb 2010 10:35:37 -0800
Message-ID: <000301caaf36$d5f86100$81e92300$@net>
MIME-Version: 1.0
Content-Type: multipart/mixed;
	boundary="----=_NextPart_000_0004_01CAAEF3.C7D52100"
X-Mailer: Microsoft Office Outlook 12.0
Thread-Index: AcqvJZyiYLzPQwZPRlOhzLz6K2IKpQADB0OA
Content-Language: en-us
X-Spam-Score: -3.5 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.4 (---)

This is a multi-part message in MIME format.

------=_NextPart_000_0004_01CAAEF3.C7D52100
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit

Alan,

>> I am now attempting to try your c-state-cache-init and find this is not
>> defined.
>
>That's exactly
>
>    M-: (c-state-cache-init)

Ahh, typed it in wrong.  I have been saving the buffer where the "
SelectInternalConvertableToVectorType" snippet is with the problematic '{'
in column 0.

So I am now able to eval your "(c-state-cache-init)" in the buffer.

The result is no difference, '{' still appears in column 0 when I TAB.
*Messages*
contains "1 (#o1, #x1)" after running it, if that means anything to you.

With regard to being more specific about what I type, that's going to be
really difficult.
Typically, I do a lot of kill - yanks, keyboard entry, and often return to
text to post-insert missing ','s or '>'s and then TAB or C-q C-j.  That's
when I discover a bad indentation case. Sometimes, by TAB-ing on previous
lines then returning to the problematic line, the indentation corrects. I
have done what you did with the snippet also - put it into a separate file,
start a separate emacs session. Each time I do that, the indentation
corrects ('{' is not in col 0) and doesn't get out of whack as I fiddle in
it. Makes me think the problem occurs with more than 1 file visited.

I am preserving the emacs session with the bad '{' indentation (col 0). Is
there any way we can narrow the issue by probing the buffer, such as with
your (c-state-cache-init) ?

Attached is the "c-submit-bug-report" run from the problematic buffer.

Bob

-----Original Message-----
From: Alan Mackenzie [mailto:acm@HIDDEN] 
Sent: Tuesday, February 16, 2010 8:39 AM
To: Bob
Cc: 'Chong Yidong'; 5570 <at> debbugs.gnu.org
Subject: Re: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting
issue.

Hi, Bob,

On Mon, Feb 15, 2010 at 09:14:52AM -0800, Bob wrote:
> Alan,

> I am now running two emacs 23.1.91.1, one I started last week with many
> files open in which I "work" etc., and one I just started with dribbling
> "on" to edit a file I have seen the issue in. After half-hours editing in
> this one, nothing bad has happened. I temporarily jumped back to the
"work"
> session to add a few needed lines and wammy! the problem appeared after
> adding 7 lines:

Could you be a little bit more exact in exactly what you did here.  I
have just fired up emacs 23.1.91, typed in 

    namespace foo
    {

(in column 0), then typed in the the lines that you've identified as
causing the error:

>   template<class _DataType>
>   struct SelectInternalConvertableToVectorType
>   {
>     typedef typename DataTypeTrait<_DataType>::TAbout	TAbout;
>
>     typedef TL::IF<TL::MemberOf<TAbout,EnumDTP::Internal>::value>
> TInternal;
>     typedef TL::IF<
> 	TL::MemberOf<TAbout,EnumDTP::HasVectorType>::value
> 	>					   TConvertableToVectorType;
> 	
>     typedef TL::IF<
>       (TInternal::value &&
> TConvertableToVectorType::value),_DataType,TL::False
>       >::Result						Result;
> };   <------------------------ Appears in column 1

However, that "};" for me appeared in the correct column, not in column
0.

> I wrote the buffer, started a 3rd emacs, went to the line, hit TAB and the
> indentation
> corrected:

That, at least, is refreshing.

>   };   <------------------------ Correct.

> Back in the original session TAB still places the '{' in column 1.

It doesn't for me.  But I _have_ seen this error happening.

So, could you please try and give me a precise recipe for how to
reproduce the error, down at the level of what the buffer should look
like before inserting these lines, and which keys to press to insert
them.  Was I correct in guessing that you typed in the lines when you
said you "added" them, as opposed to, say, C-y?

> I am now attempting to try your c-state-cache-init and find this is not
> defined.

That's exactly

    M-: (c-state-cache-init)

, including the parens round the word.  Are you certain you typed it
correctly?  It should be there in Emacs 23.1.91.

> Please advise what to do. I've attached "describe-bindings" if that helps.


> Thanks,
> Bob

> PS "C-c C-b" runs "c-submit-bug-report" - is that what you expect?

Yes.  It produces a dump of CC Mode's config as part of a mail buffer.
Cut and paste it into your own mail client.

-- 
Alan Mackenzie (Nuremberg, Germany).

------=_NextPart_000_0004_01CAAEF3.C7D52100
Content-Type: application/octet-stream;
	name="Mail"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: attachment;
	filename="Mail"

To: bug-cc-mode@HIDDEN
Subject: CC Mode 5.31.8 (C++/la); Incorrect indentation
From: Bob@HIDDEN
X-Reporter-Void-Vars-Found: auto-fill-mode (setq
 c-basic-offset 2
 c-comment-only-line-offset '(0 . 0)
 c-indent-comment-alist '((anchored-comment column . 0) (end-block space =
. 1)
			  (cpp-end-block space . 2))
 c-indent-comments-syntactically-p nil
 c-block-comment-prefix ""
 c-comment-prefix-regexp '((pike-mode . "//+!?\\|\\**") (awk-mode . =
"#+")
			   (other . "//+\\|\\**"))
 c-doc-comment-style '((java-mode . javadoc) (pike-mode . autodoc)
		       (c-mode . gtkdoc))
 c-cleanup-list '(scope-operator)
 c-hanging-braces-alist '((substatement-open before after)
			  (arglist-cont-nonempty))
 c-hanging-colons-alist nil
 c-hanging-semi&comma-criteria '(c-semi&comma-inside-parenlist)
 c-backslash-column 48
 c-backslash-max-column 72
 c-special-indent-hook '(c-gnu-impose-minimum)
 c-label-minimum-indentation 1
 c-offsets-alist '((inexpr-class . +)
		   (inexpr-statement . +)
		   (lambda-intro-cont . +)
		   (inlambda . c-lineup-inexpr-block)
		   (template-args-cont c-lineup-template-args +)
		   (incomposition . +)
		   (inmodule . +)
		   (innamespace . +)
		   (inextern-lang . +)
		   (composition-close . 0)
		   (module-close . 0)
		   (namespace-close . 0)
		   (extern-lang-close . 0)
		   (composition-open . 0)
		   (module-open . 0)
		   (namespace-open . 0)
		   (extern-lang-open . 0)
		   (objc-method-call-cont
		    c-lineup-ObjC-method-call-colons
		    c-lineup-ObjC-method-call
		    +
		    )
		   (objc-method-args-cont . c-lineup-ObjC-method-args)
		   (objc-method-intro . [0])
		   (friend . 0)
		   (cpp-define-intro c-lineup-cpp-define +)
		   (cpp-macro-cont . +)
		   (cpp-macro . [0])
		   (inclass . +)
		   (arglist-cont c-lineup-gcc-asm-reg 0)
		   (comment-intro
		    c-lineup-knr-region-comment
		    c-lineup-comment
		    )
		   (catch-clause . 0)
		   (else-clause . 0)
		   (do-while-closure . 0)
		   (access-label . -)
		   (case-label . 0)
		   (substatement . +)
		   (statement-case-intro . +)
		   (statement . 0)
		   (brace-entry-open . 0)
		   (brace-list-entry . 0)
		   (brace-list-intro . +)
		   (brace-list-close . 0)
		   (block-close . 0)
		   (block-open . 0)
		   (inher-intro . +)
		   (member-init-cont . c-lineup-multi-inher)
		   (member-init-intro . +)
		   (topmost-intro . 0)
		   (knr-argdecl . 0)
		   (func-decl-cont . +)
		   (inline-close . 0)
		   (class-close . 0)
		   (class-open . 0)
		   (defun-block-intro . +)
		   (defun-close . 0)
		   (defun-open . 0)
		   (c . c-lineup-C-comments)
		   (string . c-lineup-dont-change)
		   (topmost-intro-cont
		    first
		    c-lineup-topmost-intro-cont
		    c-lineup-gnu-DEFUN-intro-cont
		    )
		   (brace-list-open . +)
		   (inline-open . 0)
		   (arglist-close . c-lineup-arglist)
		   (arglist-intro . c-lineup-arglist-intro-after-paren)
		   (statement-case-open . +)
		   (label . 0)
		   (substatement-label . 0)
		   (knr-argdecl-intro . 5)
		   (statement-block-intro . +)
		   (statement-cont . 0)
		   (arglist-cont-nonempty . 0)
		   (stream-op . 0)
		   (inher-cont . 0)
		   (substatement-open . 0)
		   )
 c-buffer-is-cc-mode 'c++-mode
 c-tab-always-indent nil
 c-syntactic-indentation t
 c-syntactic-indentation-in-macros t
 c-ignore-auto-fill '(string cpp code)
 c-auto-align-backslashes t
 c-backspace-function 'backward-delete-char-untabify
 c-delete-function 'delete-char
 c-electric-pound-behavior nil
 c-default-style '((java-mode . "java") (awk-mode . "awk") (other . =
"gnu"))
 c-enable-xemacs-performance-kludge-p nil
 c-old-style-variable-behavior nil
 defun-prompt-regexp nil
 tab-width 8
 comment-column 32
 parse-sexp-ignore-comments t
 parse-sexp-lookup-properties t
 auto-fill-function nil
 comment-multi-line t
 comment-start-skip "\\(//+\\|/\\*+\\)\\s *"
 fill-prefix nil
 fill-column 70
 paragraph-start "[ 	]*\\(//+\\|\\**\\)[ 	]*$\\|^\f"
 adaptive-fill-mode t
 adaptive-fill-regexp "[ 	]*\\(//+\\|\\**\\)[ 	]*\\([ 	=
]*\\([-!|#%;>*=C2=B7=E2=80=A2=E2=80=A3=E2=81=83=E2=97=A6]+[ 	]*\\)*\\)"
 )

--text follows this line--


Emacs  : GNU Emacs 23.1.91.1 (i386-mingw-nt6.0.6002)
 of 2010-01-02 on PRETEST
Package: CC Mode 5.31.8 (C++/la)
Buffer Style: gnu
c-emacs-features: (pps-extended-state col-0-paren posix-char-classes =
gen-string-delim gen-comment-delim syntax-properties 1-bit)

current state:
=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D=3D

------=_NextPart_000_0004_01CAAEF3.C7D52100--





Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB	indenting	issue.
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Wed, 17 Feb 2010 09:40:03 +0000
Resent-Message-ID: <handler.5570.B5570.12663995821953 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Bob <purchasebyemail1@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12663995821953
          (code B ref 5570); Wed, 17 Feb 2010 09:40:03 +0000
Received: (at 5570) by debbugs.gnu.org; 17 Feb 2010 09:39:42 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NhgNi-0000VS-Fv
	for submit <at> debbugs.gnu.org; Wed, 17 Feb 2010 04:39:42 -0500
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NhgNg-0000VL-63
	for 5570 <at> debbugs.gnu.org; Wed, 17 Feb 2010 04:39:41 -0500
Received: (qmail 24226 invoked by uid 3782); 17 Feb 2010 09:39:36 -0000
Received: from acm.muc.de (pD9E22D47.dip.t-dialin.net [217.226.45.71]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Wed, 17 Feb 2010 10:39:35 +0100
Received: (qmail 3273 invoked by uid 1000); 17 Feb 2010 09:46:52 -0000
Date: Wed, 17 Feb 2010 09:46:52 +0000
Message-ID: <20100217094652.GC2392@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<87pr494md5.fsf@HIDDEN>
	<000e01caad1e$dcbfc560$963f5020$@net>
	<876360s8rw.fsf@HIDDEN> <20100214201006.GA6169@HIDDEN>
	<000001caae62$638af6c0$2aa0e440$@net>
	<20100216163923.GB3456@HIDDEN>
	<000301caaf36$d5f86100$81e92300$@net>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <000301caaf36$d5f86100$81e92300$@net>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.9 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

Hi, Bob,

On Tue, Feb 16, 2010 at 10:35:37AM -0800, Bob wrote:
> Alan,

> >> I am now attempting to try your c-state-cache-init and find this is not
> >> defined.

> >That's exactly

> >    M-: (c-state-cache-init)

> Ahh, typed it in wrong.  I have been saving the buffer where the "
> SelectInternalConvertableToVectorType" snippet is with the problematic '{'
> in column 0.

> So I am now able to eval your "(c-state-cache-init)" in the buffer.

> The result is no difference, '{' still appears in column 0 when I TAB.
> *Messages*
> contains "1 (#o1, #x1)" after running it, if that means anything to you.

Yes, thanks.  The "1 .." is just random noise.  The fact that
`c-state-cache-init' fixes nothing tells me that the bug's not to do with
a massive overhaul of the "state cache" (a cache of brace/paren/bracket
positions) I committed several months ago.

> With regard to being more specific about what I type, that's going to be
> really difficult.

OK, I understand that.

> Typically, I do a lot of kill - yanks, keyboard entry, and often return
> to text to post-insert missing ','s or '>'s and then TAB or C-q C-j.
> That's when I discover a bad indentation case. Sometimes, by TAB-ing on
> previous lines then returning to the problematic line, the indentation
> corrects. I have done what you did with the snippet also - put it into
> a separate file, start a separate emacs session. Each time I do that,
> the indentation corrects ('{' is not in col 0) and doesn't get out of
> whack as I fiddle in it. Makes me think the problem occurs with more
> than 1 file visited.

I have a hyptothesis: noramlly, when you type in a < or > which "looks
like" a template delimiter, CC Mode marks it as an openining/closing
parenthesis.  These can, and do, get confused with "proper" parens, { } (
) [ ], sometimes.  It seems likely that on certain deletions, these
marked <s and >s become unbalanced, and this confuses the indentation.

I committed a fix for this on 2010-02-04, barely 2 weeks ago.  This fix
ensures that these marks only get applied to < and > in balanced pairs,
and when stuff is deleted does the Right Thing.  The fix hasn't yet found
its way into a pretest.  If you test on the bzr head, could you try it
out, please.  Otherwise, please be patient and try it out on the NEXT
pretest version, when that gets released.

> I am preserving the emacs session with the bad '{' indentation (col 0).
> Is there any way we can narrow the issue by probing the buffer, such as
> with your (c-state-cache-init) ?

Could you perhaps test the above hypothesis, please?  Turn on
`show-paren-mode'.  When you next hit this bad state in a buffer, place
point on a < or >, and see if it mismatches with a proper paren/brace.

> Attached is the "c-submit-bug-report" run from the problematic buffer.

Much appreciated.

> Bob

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and	TAB	indenting	issue.
Resent-From: "Bob" <purchasebyemail1@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Wed, 17 Feb 2010 16:41:02 +0000
Resent-Message-ID: <handler.5570.B5570.126642483821250 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: "'Alan Mackenzie'" <acm@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126642483821250
          (code B ref 5570); Wed, 17 Feb 2010 16:41:02 +0000
Received: (at 5570) by debbugs.gnu.org; 17 Feb 2010 16:40:38 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Nhmx4-0005Wh-8J
	for submit <at> debbugs.gnu.org; Wed, 17 Feb 2010 11:40:38 -0500
Received: from qmta05.emeryville.ca.mail.comcast.net ([76.96.30.48])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Nhmx2-0005WZ-Nz
	for 5570 <at> debbugs.gnu.org; Wed, 17 Feb 2010 11:40:37 -0500
Received: from omta16.emeryville.ca.mail.comcast.net ([76.96.30.72])
	by qmta05.emeryville.ca.mail.comcast.net with comcast
	id j1ii1d0011ZMdJ4A54gYlP; Wed, 17 Feb 2010 16:40:32 +0000
Received: from Cache ([71.202.16.94])
	by omta16.emeryville.ca.mail.comcast.net with comcast
	id j4id1d00221mHQP8c4ijog; Wed, 17 Feb 2010 16:42:49 +0000
From: "Bob" <purchasebyemail1@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>	<87pr494md5.fsf@HIDDEN>	<000e01caad1e$dcbfc560$963f5020$@net>	<876360s8rw.fsf@HIDDEN>
	<20100214201006.GA6169@HIDDEN>	<000001caae62$638af6c0$2aa0e440$@net>	<20100216163923.GB3456@HIDDEN>	<000301caaf36$d5f86100$81e92300$@net>
	<20100217094652.GC2392@HIDDEN>
In-Reply-To: <20100217094652.GC2392@HIDDEN>
Date: Wed, 17 Feb 2010 08:40:36 -0800
Message-ID: <000301caafef$f64d3520$e2e79f60$@net>
MIME-Version: 1.0
Content-Type: multipart/mixed;
	boundary="----=_NextPart_000_0004_01CAAFAC.E829F520"
X-Mailer: Microsoft Office Outlook 12.0
Thread-Index: AcqvtSBXMSmisxwESJOoYruD+NFUvQAN/hEg
Content-Language: en-us
X-Spam-Score: -2.6 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.5 (--)

This is a multi-part message in MIME format.

------=_NextPart_000_0004_01CAAFAC.E829F520
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit

Alan,

Attached is "Foo.cpp" and "dribble" (if I did it correctly, dribble recorded
what I typed).

It illustrates a case where indentation is one level deeper than it should
be. (The other case we've been working on is one level shallower than it
should be). Maybe they are related?

visit-file "Foo.cpp", note indentation for "class Bar" is too deep. Now, TAB
on the "class Bar" line the indentation corrects. If you reconstruct the
file from "dribble" you should see TAB on the "class Bar" line incorrectly
indents too deep.

My ".emacs" file sets indentation to 2 spaces. I would guess there is an
issue where
the default (I think 4 spaces) is being used instead of my setting.

I've also attached my ".emacs" file as "emacs_init" (Outlook doesn't attach
files without a file-name). Please excuse the accumulation of junk in it
from many years of emacs use and
recommendations obtained from internet sites.

Bob

Foo.cpp:
----------------------------------------
template<
    class Bar,
    int _depth = -1
    >
class Foo;

template<
  int _depth = -1
  >
class Foo
{
};
-----------------------------------------

------=_NextPart_000_0004_01CAAFAC.E829F520
Content-Type: application/octet-stream;
	name="dribble"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: attachment;
	filename="dribble"

class Foo=01=0A=
=05=0A=
{}=10;=10=10=10=10<return>template<=0A=
>=10=05=0A=
int _depth =3D -1=01<tab>=10=01 =
0x4000020=0E=0E=0E=0E<escape>w=10=10=10=10=19=10=05;=10=10=10=10=05=0A=
class =
Bar,=0E=01<tab>=0E=01<tab>=0E=01<tab>=0E=0E=0E<tab>=10=10=10=10=10=10<tab=
>=18=13<down-mouse-1><mouse-movement><mouse-movement><mouse-movement><mou=
se-movement><mouse-movement><mouse-movement><mouse-movement><mouse-moveme=
nt><mouse-movement><mouse-movement><mouse-movement><mouse-movement><mouse=
-movement><mouse-movement><mouse-movement><mouse-movement><mouse-movement=
><mouse-movement><mouse-movement><mouse-movement><mouse-movement><mouse-m=
ovement><drag-mouse-1><help-echo>=18=03yes<return>
------=_NextPart_000_0004_01CAAFAC.E829F520
Content-Type: text/plain;
	name="Foo.cpp"
Content-Transfer-Encoding: 7bit
Content-Disposition: attachment;
	filename="Foo.cpp"


template<
    class Bar,
    int _depth = -1
    >
class Foo;

template<
  int _depth = -1
  >
class Foo
{
};

  

------=_NextPart_000_0004_01CAAFAC.E829F520
Content-Type: application/octet-stream;
	name="emacs_init"
Content-Transfer-Encoding: quoted-printable
Content-Disposition: attachment;
	filename="emacs_init"

; To see ^M or write the file without ^M=0A=
; M-X set-variable<RET>=0A=
; inhibit-eol-conversion<RET>=0A=
; t<RET>=0A=
=0A=
;(set-face-font default "Lucida Console")=0A=
;(set-default-font "Lucida Console")=0A=
=0A=
(setenv "PATH" (concat "c:/cygwin/bin;" (getenv "PATH")))=0A=
(setq exec-path (cons "c:/cygwin/bin/" exec-path))=0A=
; Set emacs path in ".bashrc"=0A=
; emacs 22.3 & 23.1 complains=0A=
;(require 'cygwin-mount)=0A=
;(cygwin-mount-activate)=0A=
=0A=
; Replace DOS shell with Cygwin Bash Shell =0A=
=0A=
(add-hook 'comint-output-filter-functions=0A=
    'shell-strip-ctrl-m nil t)=0A=
(add-hook 'comint-output-filter-functions=0A=
    'comint-watch-for-password-prompt nil t)=0A=
(setq explicit-shell-file-name "bash.exe")=0A=
;; For subprocesses invoked via the shell=0A=
;; (e.g., "shell -c command")=0A=
(setq shell-file-name explicit-shell-file-name)=0A=
=0A=
=0A=
; Key Binding for Previous Commands =0A=
; Some people like to use the up and down arrow keys to traverse through =
the previous commands. Here is the way to bind the keys. =0A=
=0A=
(add-hook 'shell-mode-hook 'n-shell-mode-hook)=0A=
(defun n-shell-mode-hook ()=0A=
  "12Jan2002 - bob, shell mode customizations."=0A=
  (local-set-key '[up] 'comint-previous-input)=0A=
  (local-set-key '[down] 'comint-next-input)=0A=
  (local-set-key '[(shift tab)] 'comint-next-matching-input-from-input)=0A=
)=0A=
=0A=
; Gzip and Gunzip =0A=
;When viewing files using the Emacs dired utility, press Z should =
compress or uncompress a file. Since Cygwin is equiped with the gzip =
utility, you should be able to get this function working on your Windows =
Gnu Emacs. The lisp statement you need in your .emacs file is =0A=
=0A=
(setq archive-zip-use-pkzip nil)=0A=
=0A=
=0A=
;=0A=
; make searches case sensitive=0A=
;=0A=
(setq         default-case-fold-search nil)=0A=
(setq-default case-fold-search nil)=0A=
=0A=
;(setq auto-mode-list '("\\.d$" . c-mode))=0A=
=0A=
; Enter c++ mode for .h files on windows - even though the file ends=0A=
; in .H emacs seems to think it's a little h and otherwise enters c mode=0A=
(setq auto-mode-alist (cons '("\\.h$" . c++-mode) auto-mode-alist))=0A=
=0A=
; C customizing=0A=
; Note these constants enforce the location of {}'s and indentation.=0A=
;=0A=
; C-h i Indentation Functions=0A=
(require 'cc-mode)=0A=
(add-hook `c-mode-common-hook (lambda () (c-toggle-auto-state 1)))=0A=
;(add-hook `c-mode-common-hook (lambda () (c-toggle-hungry-state 1)))=0A=
; left '{' not indented=0A=
(c-set-offset 'substatement-open 0)=0A=
; c-lineup-multi-inher=0A=
(c-set-offset 'inher-cont 0)=0A=
; c-lineup-streamop=0A=
(c-set-offset 'stream-op 0)=0A=
; c-lineup-arglist=0A=
(c-set-offset 'arglist-cont-nonempty 0)=0A=
; c-lineup-arglist=0A=
;(c-set-offset 'arglist-intro 0)=0A=
;(c-set-offset 'arglist-close 0)=0A=
; c-lineup-math=0A=
(c-set-offset 'statement-cont 0)=0A=
; <RET> does auto indentation, like C-n=0A=
;(define-key c-mode-base-map "\C-m" 'c-context-line-break)=0A=
; syntax coloring=0A=
(global-font-lock-mode 1)=0A=
=0A=
;(setq c-auto-newline t)=0A=
(setq c-tab-always-indent nil)=0A=
;(setq c-indent-level 4)=0A=
;(setq c-continued-statement-offset 4)=0A=
;(setq c-brace-offset -4)=0A=
;(setq c-brace-imaginary-offset 0)=0A=
;(setq c-argdecl-indent 2)=0A=
;(setq c-label-offset -4)=0A=
;(setq comment-multi-line t)=0A=
;(setq comment-start-skip "/\\*+[ \\n\\t]*")=0A=
;(setq comment-start "/*")=0A=
;(setq comment-end "*/")=0A=
=0A=
; Matching '{' '}' , '<' '>', '[' ']' are hilighted=0A=
(show-paren-mode)=0A=
=0A=
;=0A=
; compilation command=0A=
;=0A=
;(setq compile-command "make" )=0A=
=0A=
;=0A=
; prevent deletion of auto saved files when the file is written=0A=
;=0A=
(setq delete-auto-save-files t)=0A=
=0A=
;=0A=
; allow recursive use of minibuffers=0A=
;=0A=
(setq enable-recursive-minibuffers t)=0A=
=0A=
;=0A=
; establish search paths to look for for programs=0A=
;=0A=
;(setq exec-path '("." "/usr/local/bin" "/usr/ucb" "/usr/bin" "/bin" =
"/mimi/devel/bin" "/mimi/emacs/etc"))=0A=
=0A=
;=0A=
; establish the imagen printer as the one to default to=0A=
;=0A=
;(setq lpr-switches "-Pim")=0A=
=0A=
;=0A=
; Regexp used by Newline command in shell mode to match subshell prompts.=0A=
;=0A=
;(setq shell-prompt-pattern "^.\.[0-9]*[0-9]>")=0A=
=0A=
;=0A=
;  Let emacs know about my P and p macros=0A=
;=0A=
;(setq shell-pushd-regexp "pushd\\|p")=0A=
;(setq shell-popd-regexp "popd")=0A=
;=0A=
=0A=
;=0A=
; Rebind ESC-r (move-to-window-line) to replace-string=0A=
;=0A=
(global-unset-key "\er")=0A=
(global-set-key "\er" 'replace-string)=0A=
=0A=
; Get rid of the tool bar icons which take up screen space by toggleing=0A=
(tool-bar-mode)=0A=
=0A=
; Choose visible flicker instead of auditable bell rings=0A=
;(setq visible-bell t)=0A=
; Or just silence the bell entirely=0A=
(set-message-beep 'silent)=0A=
=0A=
; See http://www.emacswiki.org/emacs/PrintingPackage#toc5=0A=
; See printing.el=0A=
; Printer must be shared on CACHE=0A=
(setq printer-name "//CACHE/HP Photosmart C7200 series")=0A=
;(setq printer-name "D:/Bob/PrintFile.ps") ; print postscript to a file=0A=
(require 'printing)		; load printing package=0A=
(setq pr-gv-command    "c:/Program Files/Ghostgum/gsview/gsview64.exe")=0A=
(setq pr-gs-command    "c:/Program Files/gs/gs8.64/bin/gswin32.exe")=0A=
(setq pr-print-using-ghostscript t) ; C7280 is not a postscript printer=0A=
(setq pr-faces-p t) ; print colors, fonts etc.=0A=
(pr-update-menus t)		; update now printer and utility menus=0A=
=0A=
=0A=
; Default scrolling of 5 lines at a time is too much. This sets it to 1 =
line=0A=
(setq mouse-wheel-scroll-amount '(1 ((shift) . 1) ((control) . nil)))=0A=
(setq mouse-wheel-progressive-speed nil)=0A=
=0A=
;=0A=
; Bind 'goto-line'=0A=
;=0A=
(global-unset-key "\C-x\C-l")=0A=
(global-set-key "\C-x\C-l" 'goto-line)=0A=
=0A=
(global-set-key [f2] 'grep)=0A=
(global-set-key [f3] 'tags-search)=0A=
=0A=
;=0A=
; Bind 'query-replace-regexp'=0A=
;=0A=
(global-unset-key "\e$")=0A=
(global-set-key "\e$" 'query-replace-regexp)=0A=
(global-unset-key "\ee")=0A=
(global-set-key "\ee" 'replace-regexp)=0A=
=0A=
;=0A=
; These re-maps are done to allow xon/xoff=0A=
;=0A=
;(global-unset-key "\C-s")=0A=
;(global-set-key "\es" 'isearch-forward)=0A=
;(global-unset-key "\C-q")=0A=
;(global-unset-key "\eq")=0A=
;(global-set-key "\eq" 'quoted-insert)=0A=
=0A=
;(load-file "/usr/local/lib/emacs/19.19/lisp/hilit19.el")=0A=
; (cond (window-system=0A=
;        (setq hilit-mode-enable-list  '(not text-mode)=0A=
;	      hilit-auto-highlight-maxout 150000=0A=
;              hilit-background-mode   'light=0A=
;              hilit-inhibit-hooks     nil=0A=
;              hilit-inhibit-rebinding nil)=0A=
; =0A=
;        (require 'hilit19)=0A=
;        ))=0A=
=0A=
=0A=
;(setq explicit-shell-file-name "C:/Program Files/Hamilton =
Shell/bin/csh.exe")=0A=
=0A=
;(load-file "d:/src/cooksrc/database/emacs-setup.el")=0A=
;(global-set-key "\ep" 'cooksrc-file-preamble)=0A=
=0A=
=0A=
;=0A=
; Easy mark.=0A=
;=0A=
;(global-set-key   "\C- " 'set-mark-command)=0A=
=0A=
;=0A=
; Easy way to clear screen and enter shell command=0A=
;=0A=
;(global-set-key   "\e\r" 'cr-top)=0A=
=0A=
;=0A=
; cr-top and freeze screen=0A=
;=0A=
;(global-set-key   "\C-x\r" 'cr-top-freeze)=0A=
=0A=
;(transient-mark-mode nil)=0A=
;(setq vc-make-backup-files 1)=0A=
;(setq vc-mistrust-permissions nil)=0A=
=0A=
;=0A=
; Region hilite when mark is active=0A=
;=0A=
(transient-mark-mode t)=0A=
=0A=
;(setq shell-file-name "c:/cygwin/bin/bash")=0A=
;(setq explicit-shell-file-name "c:/cygwin/bin/bash")=0A=
(shell)=0A=
;(eshell)=0A=
;(eshell-command-result "rm -f BROWSE; ebrowse *.h *.cpp *.xml")=0A=
;(shell-command "rm -f BROWSE; ebrowse smt2/maxflowsttest.cpp *.y *.l =
*.cpp *.xml")=0A=
;(rename-buffer "sh-cook")=0A=
;(shell-command "cd d:/bob")=0A=
;(shell)=0A=
;(rename-buffer "sh-endogLib")=0A=
;(shell-command "cd d:/endogLib; rm -f BROWSE; ebrowse */*.h")=0A=
;(shell-process-cd "d:/endogLib")=0A=
;(eshell)=0A=
;(rename-buffer "sh-endogLib")=0A=
;(make-frame-command)=0A=
;(find-file "BROWSE")=0A=
;(global-set-key   "\C-x4." 'ebrowse-tags-find-definition-other-window)=0A=
;(global-set-key   "\C-x."  'ebrowse-tags-find-definition)=0A=
;(global-set-key   "=1B,"    'ebrowse-tags-loop-continue)=0A=
=0A=
=0A=
(put 'upcase-region 'disabled nil)=0A=
=0A=
(put 'downcase-region 'disabled nil)=0A=
=0A=

------=_NextPart_000_0004_01CAAFAC.E829F520--





Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and	TAB	indenting	issue.
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 18 Feb 2010 15:06:02 +0000
Resent-Message-ID: <handler.5570.B5570.126650554011787 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Bob <purchasebyemail1@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126650554011787
          (code B ref 5570); Thu, 18 Feb 2010 15:06:02 +0000
Received: (at 5570) by debbugs.gnu.org; 18 Feb 2010 15:05:40 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ni7wh-000344-3Q
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2010 10:05:39 -0500
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1Ni7wf-00033z-Bp
	for 5570 <at> debbugs.gnu.org; Thu, 18 Feb 2010 10:05:38 -0500
Received: (qmail 1559 invoked by uid 3782); 18 Feb 2010 15:05:31 -0000
Received: from acm.muc.de (pD9E2231A.dip.t-dialin.net [217.226.35.26]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Thu, 18 Feb 2010 16:05:29 +0100
Received: (qmail 7771 invoked by uid 1000); 18 Feb 2010 15:12:50 -0000
Date: Thu, 18 Feb 2010 15:12:50 +0000
Message-ID: <20100218151250.GD2671@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<87pr494md5.fsf@HIDDEN>
	<000e01caad1e$dcbfc560$963f5020$@net>
	<876360s8rw.fsf@HIDDEN> <20100214201006.GA6169@HIDDEN>
	<000001caae62$638af6c0$2aa0e440$@net>
	<20100216163923.GB3456@HIDDEN>
	<000301caaf36$d5f86100$81e92300$@net>
	<20100217094652.GC2392@HIDDEN>
	<000301caafef$f64d3520$e2e79f60$@net>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <000301caafef$f64d3520$e2e79f60$@net>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.8 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

Hi, Bob,

On Wed, Feb 17, 2010 at 08:40:36AM -0800, Bob wrote:
> Alan,

> Attached is "Foo.cpp" and "dribble" (if I did it correctly, dribble recorded
> what I typed).

> It illustrates a case where indentation is one level deeper than it should
> be. (The other case we've been working on is one level shallower than it
> should be). Maybe they are related?

I suspect not, but who knows?  :-(

However, I can reproduce this bug; the dribble file and your CC Mode
configuration file were utterly essential to my doing so.  Thanks!

> visit-file "Foo.cpp", note indentation for "class Bar" is too deep. Now, TAB
> on the "class Bar" line the indentation corrects. If you reconstruct the
> file from "dribble" you should see TAB on the "class Bar" line incorrectly
> indents too deep.

Yes.

> My ".emacs" file sets indentation to 2 spaces. I would guess there is an
> issue where
> the default (I think 4 spaces) is being used instead of my setting.

No, that's not it.  In the course of creating this file, as per your
dribble, some "text properties" (deep in the bowels of CC Mode) are being
spuriously applied to certain characters in the buffer.  I'll track down
exactly which keystroke provoked this, and hopefully be able to fix it
sometime soonish.

Thanks for taking all this trouble to help me reproduce the bug.

> Bob

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q"	and	TAB	indenting	issue.
Resent-From: "Bob" <purchasebyemail1@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 18 Feb 2010 15:54:02 +0000
Resent-Message-ID: <handler.5570.B5570.126650839514066 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: "'Alan Mackenzie'" <acm@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126650839514066
          (code B ref 5570); Thu, 18 Feb 2010 15:54:02 +0000
Received: (at 5570) by debbugs.gnu.org; 18 Feb 2010 15:53:15 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ni8gk-0003ep-Uk
	for submit <at> debbugs.gnu.org; Thu, 18 Feb 2010 10:53:15 -0500
Received: from qmta02.emeryville.ca.mail.comcast.net ([76.96.30.24])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <purchasebyemail1@HIDDEN>) id 1Ni8gj-0003ei-BM
	for 5570 <at> debbugs.gnu.org; Thu, 18 Feb 2010 10:53:13 -0500
Received: from omta18.emeryville.ca.mail.comcast.net ([76.96.30.74])
	by qmta02.emeryville.ca.mail.comcast.net with comcast
	id jTJd1d0061bwxycA2Tt9ub; Thu, 18 Feb 2010 15:53:09 +0000
Received: from Cache ([71.202.16.94])
	by omta18.emeryville.ca.mail.comcast.net with comcast
	id jTvC1d00R21mHQP8eTvDhb; Thu, 18 Feb 2010 15:55:13 +0000
From: "Bob" <purchasebyemail1@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>	<87pr494md5.fsf@HIDDEN>	<000e01caad1e$dcbfc560$963f5020$@net>	<876360s8rw.fsf@HIDDEN>
	<20100214201006.GA6169@HIDDEN>	<000001caae62$638af6c0$2aa0e440$@net>	<20100216163923.GB3456@HIDDEN>	<000301caaf36$d5f86100$81e92300$@net>	<20100217094652.GC2392@HIDDEN>	<000301caafef$f64d3520$e2e79f60$@net>
	<20100218151250.GD2671@HIDDEN>
In-Reply-To: <20100218151250.GD2671@HIDDEN>
Date: Thu, 18 Feb 2010 07:53:34 -0800
Message-ID: <002101cab0b2$879ed0c0$96dc7240$@net>
MIME-Version: 1.0
Content-Type: text/plain;
	charset="us-ascii"
Content-Transfer-Encoding: 7bit
X-Mailer: Microsoft Office Outlook 12.0
Thread-Index: Acqwq9MJ6N6j4wQIQ++jCnhX03lOVQABjc5w
Content-Language: en-us
X-Spam-Score: -3.1 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.0 (---)

Alan,

That's good news! Please let me know when you get it fixed and I'd like to
try it out.

BTW, the indenting and paren matching is a world better than 21.2, esp. with
regard to template '<' and '>' characters. Good job!

Bob

-----Original Message-----
From: Alan Mackenzie [mailto:acm@HIDDEN] 
Sent: Thursday, February 18, 2010 7:13 AM
To: Bob
Cc: 'Chong Yidong'; 5570 <at> debbugs.gnu.org
Subject: Re: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting
issue.

Hi, Bob,

On Wed, Feb 17, 2010 at 08:40:36AM -0800, Bob wrote:
> Alan,

> Attached is "Foo.cpp" and "dribble" (if I did it correctly, dribble
recorded
> what I typed).

> It illustrates a case where indentation is one level deeper than it should
> be. (The other case we've been working on is one level shallower than it
> should be). Maybe they are related?

I suspect not, but who knows?  :-(

However, I can reproduce this bug; the dribble file and your CC Mode
configuration file were utterly essential to my doing so.  Thanks!

> visit-file "Foo.cpp", note indentation for "class Bar" is too deep. Now,
TAB
> on the "class Bar" line the indentation corrects. If you reconstruct the
> file from "dribble" you should see TAB on the "class Bar" line incorrectly
> indents too deep.

Yes.

> My ".emacs" file sets indentation to 2 spaces. I would guess there is an
> issue where
> the default (I think 4 spaces) is being used instead of my setting.

No, that's not it.  In the course of creating this file, as per your
dribble, some "text properties" (deep in the bowels of CC Mode) are being
spuriously applied to certain characters in the buffer.  I'll track down
exactly which keystroke provoked this, and hopefully be able to fix it
sometime soonish.

Thanks for taking all this trouble to help me reproduce the bug.

> Bob

-- 
Alan Mackenzie (Nuremberg, Germany).





Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q"	and	TAB	indenting	issue.
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 19 Feb 2010 20:28:02 +0000
Resent-Message-ID: <handler.5570.B5570.126661125127542 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Bob <purchasebyemail1@HIDDEN>
Cc: 'Chong Yidong' <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126661125127542
          (code B ref 5570); Fri, 19 Feb 2010 20:28:02 +0000
Received: (at 5570) by debbugs.gnu.org; 19 Feb 2010 20:27:31 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NiZRe-0007A9-J9
	for submit <at> debbugs.gnu.org; Fri, 19 Feb 2010 15:27:30 -0500
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NiZRb-0007A2-Bs
	for 5570 <at> debbugs.gnu.org; Fri, 19 Feb 2010 15:27:25 -0500
Received: (qmail 94789 invoked by uid 3782); 19 Feb 2010 20:27:18 -0000
Received: from acm.muc.de (pD9E23BB4.dip.t-dialin.net [217.226.59.180]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Fri, 19 Feb 2010 21:27:16 +0100
Received: (qmail 3671 invoked by uid 1000); 19 Feb 2010 20:34:37 -0000
Date: Fri, 19 Feb 2010 20:34:37 +0000
Message-ID: <20100219203437.GA3487@HIDDEN>
References: <000e01caad1e$dcbfc560$963f5020$@net>
	<876360s8rw.fsf@HIDDEN> <20100214201006.GA6169@HIDDEN>
	<000001caae62$638af6c0$2aa0e440$@net>
	<20100216163923.GB3456@HIDDEN>
	<000301caaf36$d5f86100$81e92300$@net>
	<20100217094652.GC2392@HIDDEN>
	<000301caafef$f64d3520$e2e79f60$@net>
	<20100218151250.GD2671@HIDDEN>
	<002101cab0b2$879ed0c0$96dc7240$@net>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <002101cab0b2$879ed0c0$96dc7240$@net>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.8 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

Hi, Bob,

I think I've got the problem nailed.  And I now think you were right
when you suggested it's related to the other indentation problems.

Would you please apply this patch to cc-mode.el, and tell me if the
problem's been fixed.

Thanks!


*** orig/cc-mode.el	2010-02-18 16:29:49.000000000 +0000
--- cc-mode.el	2010-02-19 20:15:14.630249504 +0000
***************
*** 635,641 ****
      (save-excursion
        (if c-get-state-before-change-functions
  	  (mapc (lambda (fn)
! 		  (funcall fn beg end))
  		c-get-state-before-change-functions))
        (if c-before-font-lock-function
  	  (funcall c-before-font-lock-function (point-min) (point-max)
--- 635,641 ----
      (save-excursion
        (if c-get-state-before-change-functions
  	  (mapc (lambda (fn)
! 		  (funcall fn (point-min) (point-max)))
  		c-get-state-before-change-functions))
        (if c-before-font-lock-function
  	  (funcall c-before-font-lock-function (point-min) (point-max)
***************
*** 1031,1036 ****
--- 1031,1044 ----
  	  (when (> beg end)
  	    (setq beg end)))
  
+ 	;; C-y is capable of spuriously converting category properties
+ 	;; c-</>-as-paren-syntax into hard syntax-table properties.  Remove
+ 	;; these when it happens.
+ 	(c-clear-char-property-with-value beg end 'syntax-table
+ 					  c-<-as-paren-syntax)
+ 	(c-clear-char-property-with-value beg end 'syntax-table
+ 					  c->-as-paren-syntax)
+ 
  	(c-trim-found-types beg end old-len) ; maybe we don't need all of these.
  	(c-invalidate-sws-region-after beg end)
  	(c-invalidate-state-cache beg)

On Thu, Feb 18, 2010 at 07:53:34AM -0800, Bob wrote:
> Alan,
> 
> That's good news! Please let me know when you get it fixed and I'd like to
> try it out.
> 
> BTW, the indenting and paren matching is a world better than 21.2, esp. with
> regard to template '<' and '>' characters. Good job!
> 
> Bob

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
References: <000301caac36$0fc0b760$2f422620$@net>
In-Reply-To: <000301caac36$0fc0b760$2f422620$@net>
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sat, 20 Feb 2010 14:08:01 +0000
Resent-Message-ID: <handler.5570.B5570.126667482817171 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126667482817171
          (code B ref 5570); Sat, 20 Feb 2010 14:08:01 +0000
Received: (at 5570) by debbugs.gnu.org; 20 Feb 2010 14:07:08 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NipzA-0004Su-7j
	for submit <at> debbugs.gnu.org; Sat, 20 Feb 2010 09:07:08 -0500
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NipbE-0003cb-1A
	for 5570 <at> debbugs.gnu.org; Sat, 20 Feb 2010 08:42:24 -0500
Received: (qmail invoked by alias); 20 Feb 2010 13:42:17 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp029) with SMTP; 20 Feb 2010 14:42:17 +0100
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX183vnwdrCQ3HoKUa0JKvRrxWobrnXAlxOOsX7CC4P
	Lo/DtmyrMcmYZU
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Sat, 20 Feb 2010 15:41:02 +0200
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="us-ascii"
Content-Transfer-Encoding: 7bit
Message-Id: <201002201541.02944.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.81999999999999995
X-Spam-Score: -0.9 (/)
X-Mailman-Approved-At: Sat, 20 Feb 2010 09:07:07 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.9 (/)

Severity: important

> Has anyone else seen this issue?

I see it so often it is not fun.  I'm currently compiling an older
Emacs version because indentation's becoming broken every second line
is unbearable.

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Feb 2010 20:55:02 +0000
Resent-Message-ID: <handler.5570.B5570.126678566111750 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Paul Pogonyshev <pogonyshev@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126678566111750
          (code B ref 5570); Sun, 21 Feb 2010 20:55:02 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Feb 2010 20:54:21 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjIom-00033T-Ar
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2010 15:54:20 -0500
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NjIok-00033K-CF
	for 5570 <at> debbugs.gnu.org; Sun, 21 Feb 2010 15:54:19 -0500
Received: (qmail 34130 invoked by uid 3782); 21 Feb 2010 20:54:13 -0000
Received: from acm.muc.de (pD9E515B0.dip.t-dialin.net [217.229.21.176]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Sun, 21 Feb 2010 21:54:12 +0100
Received: (qmail 4717 invoked by uid 1000); 21 Feb 2010 21:01:36 -0000
Date: Sun, 21 Feb 2010 21:01:36 +0000
Message-ID: <20100221210136.GB4407@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201002201541.02944.pogonyshev@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <201002201541.02944.pogonyshev@HIDDEN>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.6 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Hi, Paul,

On Sat, Feb 20, 2010 at 03:41:02PM +0200, Paul Pogonyshev wrote:
> Severity: important

> > Has anyone else seen this issue?

> I see it so often it is not fun.  I'm currently compiling an older
> Emacs version because indentation's becoming broken every second line
> is unbearable.

Apologies.  Please bear with me on this.  It should become stable well
before the release of Emacs 23.2.

Is there any chance you could say the sort of editing you've been doing
which provokes this mis-indentation?  Do you use C-y a lot?  Is it only
in C++ Mode, or are other modes (C, Java, ....) affected?

Any chance you might try the head versions in the bzr repository?

> Paul

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Feb 2010 21:22:02 +0000
Resent-Message-ID: <handler.5570.B5570.126678728713360 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Alan Mackenzie <acm@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126678728713360
          (code B ref 5570); Sun, 21 Feb 2010 21:22:02 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Feb 2010 21:21:27 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjJF0-0003TQ-OD
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2010 16:21:27 -0500
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NjJ53-0003L1-61
	for 5570 <at> debbugs.gnu.org; Sun, 21 Feb 2010 16:11:10 -0500
Received: (qmail invoked by alias); 21 Feb 2010 21:11:03 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp071) with SMTP; 21 Feb 2010 22:11:03 +0100
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX199N5Egsul9i3nrHXL8DLlo+P14C4B0wN/JKEd+vL
	gWrt3txm8+mdyG
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Sun, 21 Feb 2010 23:09:42 +0200
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
References: <000301caac36$0fc0b760$2f422620$@net>
	<201002201541.02944.pogonyshev@HIDDEN>
	<20100221210136.GB4407@HIDDEN>
In-Reply-To: <20100221210136.GB4407@HIDDEN>
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: 7bit
Message-Id: <201002212309.43107.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.55000000000000004
X-Spam-Score: -0.7 (/)
X-Mailman-Approved-At: Sun, 21 Feb 2010 16:21:25 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.5 (/)

Alan Mackenzie wrote:
> On Sat, Feb 20, 2010 at 03:41:02PM +0200, Paul Pogonyshev wrote:
> > Severity: important
> 
> > > Has anyone else seen this issue?
> 
> > I see it so often it is not fun.  I'm currently compiling an older
> > Emacs version because indentation's becoming broken every second line
> > is unbearable.
> 
> Apologies.  Please bear with me on this.  It should become stable well
> before the release of Emacs 23.2.
> 
> Is there any chance you could say the sort of editing you've been doing
> which provokes this mis-indentation?  Do you use C-y a lot?  Is it only
> in C++ Mode, or are other modes (C, Java, ....) affected?

Mostly in C++ Mode, with usually with quite complicated code
(templates), but not only.  E.g. I lost patience with it on a file
without templates where only more or less non-common thing was a local
namespace.  It looks basically like this (using my preferred
indentation style, might be important):

namespace
{
  class Foo : public Bar
  {
  public:

    virtual  void
    bla_bla (some_type& x, const string& y)
    {
      ...
    }

    ...
  };
}

It used to break heavily in such functions (there are many similar)
inside a local class.  Function names were becoming colored with
'font-lock-variable-name-face' and as such indented wrongly.

> Any chance you might try the head versions in the bzr repository?

OK, but a bit later.  I guess it is of little help, but currently I
use revision 98816 (just chose one at random) and cc-mode works fine.

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Feb 2010 21:50:02 +0000
Resent-Message-ID: <handler.5570.B5570.126678899015105 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Paul Pogonyshev <pogonyshev@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126678899015105
          (code B ref 5570); Sun, 21 Feb 2010 21:50:02 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Feb 2010 21:49:50 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjJgU-0003va-0X
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2010 16:49:50 -0500
Received: from pantheon-po25.its.yale.edu ([130.132.50.119])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1NjJgS-0003vT-Dt
	for 5570 <at> debbugs.gnu.org; Sun, 21 Feb 2010 16:49:48 -0500
Received: from furry (173-14-147-246-NewEngland.hfc.comcastbusiness.net
	[173.14.147.246]) (authenticated bits=0)
	by pantheon-po25.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o1LLniRh002869
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Sun, 21 Feb 2010 16:49:44 -0500
Received: by furry (Postfix, from userid 1000)
	id D53D6C05D; Sun, 21 Feb 2010 16:49:43 -0500 (EST)
From: Chong Yidong <cyd@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201002201541.02944.pogonyshev@HIDDEN> <20100221210136.GB4407@HIDDEN>
	<201002212309.43107.pogonyshev@HIDDEN>
Date: Sun, 21 Feb 2010 16:49:43 -0500
In-Reply-To: <201002212309.43107.pogonyshev@HIDDEN> (Paul Pogonyshev's
	message of "Sun, 21 Feb 2010 23:09:42 +0200")
Message-ID: <87hbpadzt4.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/23.1.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -3.3 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.3 (---)

Paul Pogonyshev <pogonyshev@HIDDEN> writes:

>> Any chance you might try the head versions in the bzr repository?
>
> OK, but a bit later.  I guess it is of little help, but currently I
> use revision 98816 (just chose one at random) and cc-mode works fine.

It would be nice if you could test the patch Alan posted at

  http://debbugs.gnu.org/cgi/bugreport.cgi?bug=5570#40

since "Bob" has not responded to the request to test it.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Feb 2010 22:05:02 +0000
Resent-Message-ID: <handler.5570.B5570.126678987816091 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126678987816091
          (code B ref 5570); Sun, 21 Feb 2010 22:05:02 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Feb 2010 22:04:38 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjJun-0004BU-R6
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2010 17:04:38 -0500
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NjJmD-00041H-1u
	for 5570 <at> debbugs.gnu.org; Sun, 21 Feb 2010 16:55:45 -0500
Received: (qmail invoked by alias); 21 Feb 2010 21:55:36 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp072) with SMTP; 21 Feb 2010 22:55:36 +0100
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX19dbCAal0ddLHZc20FoDdkVoCu6by5ac58ylQArab
	5JadKuo3kEpmJq
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Sun, 21 Feb 2010 23:54:23 +0200
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
References: <000301caac36$0fc0b760$2f422620$@net>
	<201002212309.43107.pogonyshev@HIDDEN>
	<87hbpadzt4.fsf@HIDDEN>
In-Reply-To: <87hbpadzt4.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: 7bit
Message-Id: <201002212354.23776.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.66000000000000003
X-Spam-Score: -0.4 (/)
X-Mailman-Approved-At: Sun, 21 Feb 2010 17:04:37 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.4 (/)

Chong Yidong wrote:
> Paul Pogonyshev <pogonyshev@HIDDEN> writes:
> 
> >> Any chance you might try the head versions in the bzr repository?
> >
> > OK, but a bit later.  I guess it is of little help, but currently I
> > use revision 98816 (just chose one at random) and cc-mode works fine.
> 
> It would be nice if you could test the patch Alan posted at
> 
>   http://debbugs.gnu.org/cgi/bugreport.cgi?bug=5570#40
> 
> since "Bob" has not responded to the request to test it.

It doesn't apply to trunk and I'd prefer not to guess how to merge.
Can you rediff it?

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Feb 2010 22:07:01 +0000
Resent-Message-ID: <handler.5570.B5570.126678998416208 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Paul Pogonyshev <pogonyshev@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126678998416208
          (code B ref 5570); Sun, 21 Feb 2010 22:07:01 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Feb 2010 22:06:24 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjJwW-0004DN-Hb
	for submit <at> debbugs.gnu.org; Sun, 21 Feb 2010 17:06:24 -0500
Received: from pantheon-po33.its.yale.edu ([130.132.50.94])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1NjJwU-0004DG-9g
	for 5570 <at> debbugs.gnu.org; Sun, 21 Feb 2010 17:06:22 -0500
Received: from furry (173-14-147-246-NewEngland.hfc.comcastbusiness.net
	[173.14.147.246]) (authenticated bits=0)
	by pantheon-po33.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o1LM6HiW008244
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Sun, 21 Feb 2010 17:06:18 -0500
Received: by furry (Postfix, from userid 1000)
	id B743AC05D; Sun, 21 Feb 2010 17:06:17 -0500 (EST)
From: Chong Yidong <cyd@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201002212309.43107.pogonyshev@HIDDEN>
	<87hbpadzt4.fsf@HIDDEN>
	<201002212354.23776.pogonyshev@HIDDEN>
Date: Sun, 21 Feb 2010 17:06:17 -0500
In-Reply-To: <201002212354.23776.pogonyshev@HIDDEN> (Paul Pogonyshev's
	message of "Sun, 21 Feb 2010 23:54:23 +0200")
Message-ID: <873a0ujlba.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/23.1.92 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -3.3 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.2 (---)

Paul Pogonyshev <pogonyshev@HIDDEN> writes:

> Chong Yidong wrote:
>> Paul Pogonyshev <pogonyshev@HIDDEN> writes:
>> 
>> >> Any chance you might try the head versions in the bzr repository?
>> >
>> > OK, but a bit later.  I guess it is of little help, but currently I
>> > use revision 98816 (just chose one at random) and cc-mode works fine.
>> 
>> It would be nice if you could test the patch Alan posted at
>> 
>>   http://debbugs.gnu.org/cgi/bugreport.cgi?bug=5570#40
>> 
>> since "Bob" has not responded to the request to test it.
>
> It doesn't apply to trunk and I'd prefer not to guess how to merge.
> Can you rediff it?

Here, try this:

*** lisp/progmodes/cc-mode.el	2010-02-06 13:01:43 +0000
--- lisp/progmodes/cc-mode.el	2010-02-21 22:05:23 +0000
***************
*** 642,652 ****
      (widen)
      (save-excursion
        (if c-get-state-before-change-functions
! 	  (let ((beg (point-min))
! 		(end (point-max)))
! 	    (mapc (lambda (fn)
! 		    (funcall fn beg end))
! 		  c-get-state-before-change-functions)))
        (if c-before-font-lock-function
  	  (funcall c-before-font-lock-function (point-min) (point-max)
  		   (- (point-max) (point-min))))))
--- 642,650 ----
      (widen)
      (save-excursion
        (if c-get-state-before-change-functions
! 	  (mapc (lambda (fn)
! 		  (funcall fn (point-min) (point-max)))
! 		c-get-state-before-change-functions))
        (if c-before-font-lock-function
  	  (funcall c-before-font-lock-function (point-min) (point-max)
  		   (- (point-max) (point-min))))))
***************
*** 1042,1047 ****
--- 1040,1053 ----
  	  (when (> beg end)
  	    (setq beg end)))
  
+ 	;; C-y is capable of spuriously converting category properties
+ 	;; c-</>-as-paren-syntax into hard syntax-table properties.  Remove
+ 	;; these when it happens.
+ 	(c-clear-char-property-with-value beg end 'syntax-table
+ 					  c-<-as-paren-syntax)
+ 	(c-clear-char-property-with-value beg end 'syntax-table
+ 					  c->-as-paren-syntax)
+ 
  	(c-trim-found-types beg end old-len) ; maybe we don't need all of these.
  	(c-invalidate-sws-region-after beg end)
  	(c-invalidate-state-cache beg)




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 22 Feb 2010 16:19:02 +0000
Resent-Message-ID: <handler.5570.B5570.12668555128234 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12668555128234
          (code B ref 5570); Mon, 22 Feb 2010 16:19:02 +0000
Received: (at 5570) by debbugs.gnu.org; 22 Feb 2010 16:18:32 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjazO-00028c-Nu
	for submit <at> debbugs.gnu.org; Mon, 22 Feb 2010 11:18:31 -0500
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NjaJ0-0001Ya-Nz
	for 5570 <at> debbugs.gnu.org; Mon, 22 Feb 2010 10:34:44 -0500
Received: (qmail invoked by alias); 22 Feb 2010 15:34:31 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp032) with SMTP; 22 Feb 2010 16:34:31 +0100
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX19CLkYQ0kRCkvnfct2FsLPi8YZloBtOhtVR0e0wUi
	xkY7AGG7g30viD
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Mon, 22 Feb 2010 17:33:14 +0200
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
References: <000301caac36$0fc0b760$2f422620$@net>
	<201002212354.23776.pogonyshev@HIDDEN>
	<873a0ujlba.fsf@HIDDEN>
In-Reply-To: <873a0ujlba.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: 7bit
Message-Id: <201002221733.15359.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.64000000000000001
X-Spam-Score: -0.3 (/)
X-Mailman-Approved-At: Mon, 22 Feb 2010 11:18:28 -0500
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.4 (/)

Chong Yidong wrote:
> Paul Pogonyshev <pogonyshev@HIDDEN> writes:
> 
> > Chong Yidong wrote:
> >> Paul Pogonyshev <pogonyshev@HIDDEN> writes:
> >> 
> >> >> Any chance you might try the head versions in the bzr repository?
> >> >
> >> > OK, but a bit later.  I guess it is of little help, but currently I
> >> > use revision 98816 (just chose one at random) and cc-mode works fine.
> >> 
> >> It would be nice if you could test the patch Alan posted at
> >> 
> >>   http://debbugs.gnu.org/cgi/bugreport.cgi?bug=5570#40
> >> 
> >> since "Bob" has not responded to the request to test it.
> >
> > It doesn't apply to trunk and I'd prefer not to guess how to merge.
> > Can you rediff it?
> 
> Here, try this: [...]

Thanks, indentation problems seem to be gone.  Or at least don't
happen nearly that often.

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: Emacs 23.1.91.1 C++ mode "ESC C-q" and TAB indenting issue.
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Tue, 23 Feb 2010 13:30:03 +0000
Resent-Message-ID: <handler.5570.B5570.12669317825727 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-Emacs-PR-Message: followup 5570
X-Emacs-PR-Package: emacs,cc-mode
X-Emacs-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, emacs-devel@HIDDEN
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12669317825727
          (code B ref 5570); Tue, 23 Feb 2010 13:30:03 +0000
Received: (at 5570) by debbugs.gnu.org; 23 Feb 2010 13:29:42 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NjupZ-0001UJ-A6
	for submit <at> debbugs.gnu.org; Tue, 23 Feb 2010 08:29:41 -0500
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NjupV-0001U8-Lr
	for 5570 <at> debbugs.gnu.org; Tue, 23 Feb 2010 08:29:40 -0500
Received: (qmail invoked by alias); 23 Feb 2010 13:29:29 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp050) with SMTP; 23 Feb 2010 14:29:29 +0100
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX1/aUawBLOTa8QyfU/1E5WooNzKyI5p5HSqECaACMm
	rvFVa13oqquFnI
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Tue, 23 Feb 2010 15:28:08 +0200
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
References: <000301caac36$0fc0b760$2f422620$@net>
	<873a0ujlba.fsf@HIDDEN>
	<201002221733.15359.pogonyshev@HIDDEN>
In-Reply-To: <201002221733.15359.pogonyshev@HIDDEN>
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: 7bit
Message-Id: <201002231528.09081.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.67000000000000004
X-Spam-Score: -0.5 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.5 (/)

I wrote:
> Thanks, indentation problems seem to be gone.  Or at least don't
> happen nearly that often.

Still happens, though much more rarely than before.  No sure way to
reproduce, but in this short source code file:

#include "engine/strategy/evaluation/material.hpp"

#include <utility>


using namespace engine;

using namespace std;


int
MaterialEvaluationFunction::do_evaluate_material (Board::PackedMaterialData material)
{
  const int  score            = _algorithm->evaluate (material);
  const int  normalized_score = ((score * get_first_rabbit_value ())
                                 / _algorithm->get_first_rabbit_value ());

_cache.insert (make_pair (material, normalized_score));
}

I'm getting wrongly indented '_cache.insert ...' line.  C-c C-s on it
also shows 'topmost-intro'.  I guess this heavily depends on the order
in which code is typed.

After I killed the buffer and reopened it, indentation is back to
normal and C-c C-s on that line correctly shows 'statement'.

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
References: <000301caac36$0fc0b760$2f422620$@net>
In-Reply-To: <000301caac36$0fc0b760$2f422620$@net>
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 18 Mar 2010 20:08:01 +0000
Resent-Message-ID: <handler.5570.B5570.126894287217958 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126894287217958
          (code B ref 5570); Thu, 18 Mar 2010 20:08:01 +0000
Received: (at 5570) by debbugs.gnu.org; 18 Mar 2010 20:07:52 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NsM0W-0004fb-78
	for submit <at> debbugs.gnu.org; Thu, 18 Mar 2010 16:07:52 -0400
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NsM0T-0004fW-4q
	for 5570 <at> debbugs.gnu.org; Thu, 18 Mar 2010 16:07:50 -0400
Received: (qmail invoked by alias); 18 Mar 2010 20:07:41 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp058) with SMTP; 18 Mar 2010 21:07:41 +0100
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX18wX2YLEOUwa6JusyXQQ9omVLpqsGZPsrnQn4ArWQ
	6VW7WBP3D08odi
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Thu, 18 Mar 2010 22:05:11 +0200
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="us-ascii"
Content-Transfer-Encoding: 7bit
Message-Id: <201003182205.12157.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.69999999999999996
X-Spam-Score: 0.8 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.9 (/)

After March the 1st changes indentation in C++ and related modes is
better, but it still breaks often enough --- to the tune of once every
3--5 minutes or so.  Both when editing C++ and Java code.

As I understand, the issue is that some cached information becomes
wrong after certain (undetermined) buffer changes.  Maybe it is better
to write an automated cache validation code rather than search for a
certain way to reproduce stuff?

E.g. just build information from scratch and assert that cached
information is the same.  Ideally, such checks should be performed
after every change, so that you'd be able to find which change exactly
trigerred a bug.  (Granted, this would make debugging version slow as
hell, but with this rate of error occurence it's not like you'd need
to run it for days.)

Without automated error detection tools cc-mode is bound to have
similar issues after every second non-trivial change.

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Thu, 18 Mar 2010 20:32:01 +0000
Resent-Message-ID: <handler.5570.B5570.126894427418571 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie  <acm@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org, Stefan Monnier <monnier@HIDDEN>, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126894427418571
          (code B ref 5570); Thu, 18 Mar 2010 20:32:01 +0000
Received: (at 5570) by debbugs.gnu.org; 18 Mar 2010 20:31:14 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NsMN5-0004pU-Ku
	for submit <at> debbugs.gnu.org; Thu, 18 Mar 2010 16:31:13 -0400
Received: from pantheon-po33.its.yale.edu ([130.132.50.94])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1NsMN4-0004pO-0y
	for 5570 <at> debbugs.gnu.org; Thu, 18 Mar 2010 16:31:10 -0400
Received: from furry (dhcp128036014175.central.yale.edu [128.36.14.175])
	(authenticated bits=0)
	by pantheon-po33.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o2IKV5km002964
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Thu, 18 Mar 2010 16:31:05 -0400
Received: by furry (Postfix, from userid 1000)
	id 7623FC011; Thu, 18 Mar 2010 16:31:05 -0400 (EDT)
From: Chong Yidong <cyd@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201003182205.12157.pogonyshev@HIDDEN>
Date: Thu, 18 Mar 2010 16:31:05 -0400
In-Reply-To: <201003182205.12157.pogonyshev@HIDDEN> (Paul Pogonyshev's
	message of "Thu, 18 Mar 2010 22:05:11 +0200")
Message-ID: <87ocilcqye.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/23.1.94 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -1.5 (-)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

Paul Pogonyshev <pogonyshev@HIDDEN> writes:

> After March the 1st changes indentation in C++ and related modes is
> better, but it still breaks often enough --- to the tune of once every
> 3--5 minutes or so.  Both when editing C++ and Java code.

This is troubling.

If the CC-mode changes are still not quite stabilized, I would like to
consider postphoning them to post-23.2.  Alan, what's your opinion?
Could we revert to the version in the branch prior to 2010-02-04 (which
IIUC is the change that introduced these problems), or do you consider
those changes too important for the release?




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 19 Mar 2010 21:49:01 +0000
Resent-Message-ID: <handler.5570.B5570.126903532831214 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Paul Pogonyshev <pogonyshev@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126903532831214
          (code B ref 5570); Fri, 19 Mar 2010 21:49:01 +0000
Received: (at 5570) by debbugs.gnu.org; 19 Mar 2010 21:48:48 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Nsk3k-00087P-Ao
	for submit <at> debbugs.gnu.org; Fri, 19 Mar 2010 17:48:48 -0400
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1Nsk3g-00087I-8n
	for 5570 <at> debbugs.gnu.org; Fri, 19 Mar 2010 17:48:46 -0400
Received: (qmail 43462 invoked by uid 3782); 19 Mar 2010 21:48:39 -0000
Received: from acm.muc.de (pD9E530D1.dip.t-dialin.net [217.229.48.209]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Fri, 19 Mar 2010 22:48:38 +0100
Received: (qmail 2355 invoked by uid 1000); 19 Mar 2010 21:56:40 -0000
Date: Fri, 19 Mar 2010 21:56:39 +0000
Message-ID: <20100319215639.GA2079@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201003182205.12157.pogonyshev@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <201003182205.12157.pogonyshev@HIDDEN>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.3 (-)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.5 (--)

Hi, Paul,

On Thu, Mar 18, 2010 at 10:05:11PM +0200, Paul Pogonyshev wrote:
> After March the 1st changes indentation in C++ and related modes is
> better, but it still breaks often enough --- to the tune of once every
> 3--5 minutes or so.  Both when editing C++ and Java code.

How about plain C?  Is the breakage connected with templates/generics, as
far as you can see?

What is the breakage like?  Is it a one-off failure which repairs itself
after a few more edits, or is it more like a creeping death?  Does
reinitializing the mode (M-x c++-mode) repair the indentation?  Does
saving the file and reloading it fix things?

Does
    M-x (c-state-cache-init)
fix it?

> As I understand, the issue is that some cached information becomes
> wrong after certain (undetermined) buffer changes.

This is very likely.

> Maybe it is better to write an automated cache validation code rather
> than search for a certain way to reproduce stuff?

For which cache, though?  Hence the questions above.  

> E.g. just build information from scratch and assert that cached
> information is the same.  Ideally, such checks should be performed
> after every change, so that you'd be able to find which change exactly
> trigerred a bug.  (Granted, this would make debugging version slow as
> hell, but with this rate of error occurence it's not like you'd need
> to run it for days.)

I should be able to get this done by, say, Monday for the "state-cache".
Again, does M-x (c-state-cache-init) clear the fault?

> Without automated error detection tools cc-mode is bound to have
> similar issues after every second non-trivial change.

I strongly believe it's a very small finite number of distinct bugs
causing the problems.  Anything more you can tell me about how it breaks
would be of the utmost help.

> Paul

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Fri, 19 Mar 2010 22:46:01 +0000
Resent-Message-ID: <handler.5570.B5570.126903874932670 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie <acm@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126903874932670
          (code B ref 5570); Fri, 19 Mar 2010 22:46:01 +0000
Received: (at 5570) by debbugs.gnu.org; 19 Mar 2010 22:45:49 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Nskwv-0008Ut-JV
	for submit <at> debbugs.gnu.org; Fri, 19 Mar 2010 18:45:49 -0400
Received: from smtprelay-h21.telenor.se ([195.54.99.196])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <jan.h.d@HIDDEN>) id 1Nskwt-0008Un-0b
	for 5570 <at> debbugs.gnu.org; Fri, 19 Mar 2010 18:45:47 -0400
Received: from ipb1.telenor.se (ipb1.telenor.se [195.54.127.164])
	by smtprelay-h21.telenor.se (Postfix) with ESMTP id 4621ADD04
	for <5570 <at> debbugs.gnu.org>; Fri, 19 Mar 2010 23:45:42 +0100 (CET)
X-SENDER-IP: [85.225.45.110]
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: ArI1ANKao0tV4S1uPGdsb2JhbACHXpNfDAEBAQE3LbskhHoE
X-IronPort-AV: E=Sophos;i="4.51,276,1267398000"; d="scan'208";a="53490470"
Received: from c-6e2de155.25-1-64736c10.cust.bredbandsbolaget.se (HELO
	coolsville.localdomain) ([85.225.45.110])
	by ipb1.telenor.se with ESMTP; 19 Mar 2010 23:45:41 +0100
Received: from [172.20.199.13] (zeplin [172.20.199.13])
	by coolsville.localdomain (Postfix) with ESMTPSA id 271C37FA01A;
	Fri, 19 Mar 2010 23:45:41 +0100 (CET)
Message-ID: <4BA3FE94.7080901@HIDDEN>
Date: Fri, 19 Mar 2010 23:45:40 +0100
From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
User-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; sv-SE;
	rv:1.9.1.8) Gecko/20100227 Thunderbird/3.0.3
MIME-Version: 1.0
References: <000301caac36$0fc0b760$2f422620$@net>	<201003182205.12157.pogonyshev@HIDDEN>
	<20100319215639.GA2079@HIDDEN>
In-Reply-To: <20100319215639.GA2079@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.4 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.3 (---)



Alan Mackenzie skrev 2010-03-19 22.56:
> Hi, Paul,
>
> On Thu, Mar 18, 2010 at 10:05:11PM +0200, Paul Pogonyshev wrote:
>> After March the 1st changes indentation in C++ and related modes is
>> better, but it still breaks often enough --- to the tune of once every
>> 3--5 minutes or so.  Both when editing C++ and Java code.
>
> How about plain C?  Is the breakage connected with templates/generics, as
> far as you can see?

FWIW, I see breakage in plain C also.

>
> What is the breakage like?  Is it a one-off failure which repairs itself
> after a few more edits, or is it more like a creeping death?  Does
> reinitializing the mode (M-x c++-mode) repair the indentation?  Does
> saving the file and reloading it fix things?

I now more or less automatically do M-x revert buffer when this happens.

	Jan D.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sat, 20 Mar 2010 13:15:02 +0000
Resent-Message-ID: <handler.5570.B5570.126909090023118 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126909090023118
          (code B ref 5570); Sat, 20 Mar 2010 13:15:02 +0000
Received: (at 5570) by debbugs.gnu.org; 20 Mar 2010 13:15:00 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NsyW4-00060p-6l
	for submit <at> debbugs.gnu.org; Sat, 20 Mar 2010 09:15:00 -0400
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NsyW1-00060k-O6
	for 5570 <at> debbugs.gnu.org; Sat, 20 Mar 2010 09:14:58 -0400
Received: (qmail 99555 invoked by uid 3782); 20 Mar 2010 13:14:51 -0000
Received: from acm.muc.de (pD9E22493.dip.t-dialin.net [217.226.36.147]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Sat, 20 Mar 2010 14:14:48 +0100
Received: (qmail 3205 invoked by uid 1000); 20 Mar 2010 13:22:50 -0000
Date: Sat, 20 Mar 2010 13:22:50 +0000
Message-ID: <20100320132250.GA2674@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201003182205.12157.pogonyshev@HIDDEN>
	<20100319215639.GA2079@HIDDEN> <4BA3FE94.7080901@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <4BA3FE94.7080901@HIDDEN>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -2.8 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

Hi, Jan,

On Fri, Mar 19, 2010 at 11:45:40PM +0100, Jan Djärv wrote:


> Alan Mackenzie skrev 2010-03-19 22.56:
> >Hi, Paul,

> >On Thu, Mar 18, 2010 at 10:05:11PM +0200, Paul Pogonyshev wrote:
> >>After March the 1st changes indentation in C++ and related modes is
> >>better, but it still breaks often enough --- to the tune of once every
> >>3--5 minutes or so.  Both when editing C++ and Java code.

> >How about plain C?  Is the breakage connected with templates/generics, as
> >far as you can see?

> FWIW, I see breakage in plain C also.

That's worth a great deal to know.  It suggests that the changes of
2010-02-04 aren't responsble for this bug.

> >What is the breakage like?  Is it a one-off failure which repairs itself
> >after a few more edits, or is it more like a creeping death?  Does
> >reinitializing the mode (M-x c++-mode) repair the indentation?  Does
> >saving the file and reloading it fix things?

> I now more or less automatically do M-x revert buffer when this happens.

When _what_ happens?  I take it, then, that revert-buffer fixes the bad
state, and you save the file first before reverting it.  Any chance you
could answer the above questions, together with the further one:

Does
    M-x (c-state-cache-init)
fix it?
    
These answers would be of the utmost help.  Thanks!

> 	Jan D.

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: "Jan D." <jan.h.d@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sat, 20 Mar 2010 14:50:02 +0000
Resent-Message-ID: <handler.5570.B5570.126909655726186 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie <acm@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126909655726186
          (code B ref 5570); Sat, 20 Mar 2010 14:50:02 +0000
Received: (at 5570) by debbugs.gnu.org; 20 Mar 2010 14:49:17 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NszzJ-0006oJ-Ea
	for submit <at> debbugs.gnu.org; Sat, 20 Mar 2010 10:49:17 -0400
Received: from smtprelay-h11.telenor.se ([62.127.194.4])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <jan.h.d@HIDDEN>) id 1NszzG-0006oD-Fe
	for 5570 <at> debbugs.gnu.org; Sat, 20 Mar 2010 10:49:15 -0400
Received: from ipb1.telenor.se (ipb1.telenor.se [195.54.127.164])
	by smtprelay-h11.telenor.se (Postfix) with ESMTP id E7002163D3
	for <5570 <at> debbugs.gnu.org>; Sat, 20 Mar 2010 15:49:08 +0100 (CET)
X-SENDER-IP: [85.225.45.110]
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: ArE3ADp9pEtV4S1uPGdsb2JhbACbPQwBAQEBNy29L4R9BA
X-IronPort-AV: E=Sophos;i="4.51,279,1267398000"; d="scan'208";a="53612060"
Received: from c-6e2de155.25-1-64736c10.cust.bredbandsbolaget.se (HELO
	coolsville.localdomain) ([85.225.45.110])
	by ipb1.telenor.se with ESMTP; 20 Mar 2010 15:49:08 +0100
Received: from [172.20.199.2] (gaffa [172.20.199.2])
	by coolsville.localdomain (Postfix) with ESMTPA id AE30C7FA01A;
	Sat, 20 Mar 2010 15:49:07 +0100 (CET)
Message-ID: <4BA4E063.50704@HIDDEN>
Date: Sat, 20 Mar 2010 15:49:07 +0100
From: "Jan D." <jan.h.d@HIDDEN>
User-Agent: Thunderbird 2.0.0.23 (Windows/20090812)
MIME-Version: 1.0
References: <000301caac36$0fc0b760$2f422620$@net>	<201003182205.12157.pogonyshev@HIDDEN>	<20100319215639.GA2079@HIDDEN>
	<4BA3FE94.7080901@HIDDEN> <20100320132250.GA2674@HIDDEN>
In-Reply-To: <20100320132250.GA2674@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -2.8 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.8 (--)

Alan Mackenzie wrote:
> Hi, Jan,
>=20
> On Fri, Mar 19, 2010 at 11:45:40PM +0100, Jan Dj=E4rv wrote:
>=20
>=20
>> Alan Mackenzie skrev 2010-03-19 22.56:
>>> Hi, Paul,
>=20
>>> On Thu, Mar 18, 2010 at 10:05:11PM +0200, Paul Pogonyshev wrote:
>>>> After March the 1st changes indentation in C++ and related modes is
>>>> better, but it still breaks often enough --- to the tune of once eve=
ry
>>>> 3--5 minutes or so.  Both when editing C++ and Java code.
>=20
>>> How about plain C?  Is the breakage connected with templates/generics=
, as
>>> far as you can see?
>=20
>> FWIW, I see breakage in plain C also.
>=20
> That's worth a great deal to know.  It suggests that the changes of
> 2010-02-04 aren't responsble for this bug.
>=20
>>> What is the breakage like?  Is it a one-off failure which repairs its=
elf
>>> after a few more edits, or is it more like a creeping death?  Does
>>> reinitializing the mode (M-x c++-mode) repair the indentation?  Does
>>> saving the file and reloading it fix things?
>=20
>> I now more or less automatically do M-x revert buffer when this happen=
s.
>=20
> When _what_ happens?=20

When C-mode thinks everything is topmost-intro.

> I take it, then, that revert-buffer fixes the bad
> state, and you save the file first before reverting it.  Any chance you
> could answer the above questions, together with the further one:
>=20
> Does
>     M-x (c-state-cache-init)
> fix it?
>    =20

No, it does not.

	Jan D.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Mar 2010 11:09:01 +0000
Resent-Message-ID: <handler.5570.B5570.1269169729321 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: "Jan D." <jan.h.d@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.1269169729321
          (code B ref 5570); Sun, 21 Mar 2010 11:09:01 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Mar 2010 11:08:49 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NtJ1U-000058-6Z
	for submit <at> debbugs.gnu.org; Sun, 21 Mar 2010 07:08:48 -0400
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1NtJ1F-00004z-Am
	for 5570 <at> debbugs.gnu.org; Sun, 21 Mar 2010 07:08:46 -0400
Received: (qmail 12518 invoked by uid 3782); 21 Mar 2010 11:08:26 -0000
Received: from acm.muc.de (pD9E52F2A.dip.t-dialin.net [217.229.47.42]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Sun, 21 Mar 2010 12:08:24 +0100
Received: (qmail 3078 invoked by uid 1000); 21 Mar 2010 11:16:28 -0000
Date: Sun, 21 Mar 2010 11:16:27 +0000
Message-ID: <20100321111627.GA2594@HIDDEN>
References: <000301caac36$0fc0b760$2f422620$@net>
	<201003182205.12157.pogonyshev@HIDDEN>
	<20100319215639.GA2079@HIDDEN> <4BA3FE94.7080901@HIDDEN>
	<20100320132250.GA2674@HIDDEN> <4BA4E063.50704@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=iso-8859-1
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <4BA4E063.50704@HIDDEN>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.2 (-)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.5 (--)

Hi, Jan

On Sat, Mar 20, 2010 at 03:49:07PM +0100, Jan D. wrote:
> Alan Mackenzie wrote:
> >On Fri, Mar 19, 2010 at 11:45:40PM +0100, Jan Djärv wrote:

> >>>How about plain C?  Is the breakage connected with
> >>>templates/generics, as far as you can see?

> >>FWIW, I see breakage in plain C also.

> >That's worth a great deal to know.  It suggests that the changes of
> >2010-02-04 aren't responsble for this bug.

> >>I now more or less automatically do M-x revert buffer when this happens.

> >When _what_ happens? 

> When C-mode thinks everything is topmost-intro.

OK.  I get the impression this is VERY annoying, but that it happens very
frequently rather than just now and then.  Good!

> >I take it, then, that revert-buffer fixes the bad
> >state, and you save the file first before reverting it.  Any chance you
> >could answer the above questions, together with the further one:

> >Does
> >    M-x (c-state-cache-init)
> >fix it?


> No, it does not.

I'm assuming your Emacs is pretty much the newest bzr version.

Would you please choose a C file, as small as will work, and start an
Emacs session with a dribble file (see page "Recording Input" in the
Elisp manual).  Edit the C file until indentation goes wrong.  Then send
me the dribble file, the (original) C file, and your CC Mode
configuration (generated by C-c C-b in the C file).

Apologies for this horrible bug, and thanks for you help in nailing it
down!

> 	Jan D.

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Sun, 21 Mar 2010 11:52:01 +0000
Resent-Message-ID: <handler.5570.B5570.12691722623324 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie <acm@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12691722623324
          (code B ref 5570); Sun, 21 Mar 2010 11:52:01 +0000
Received: (at 5570) by debbugs.gnu.org; 21 Mar 2010 11:51:02 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NtJgL-0000rZ-Tq
	for submit <at> debbugs.gnu.org; Sun, 21 Mar 2010 07:51:02 -0400
Received: from smtprelay-b12.telenor.se ([62.127.194.21])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <jan.h.d@HIDDEN>) id 1NtJgJ-0000rM-NW
	for 5570 <at> debbugs.gnu.org; Sun, 21 Mar 2010 07:51:00 -0400
Received: from ipb2.telenor.se (ipb2.telenor.se [195.54.127.165])
	by smtprelay-b12.telenor.se (Postfix) with ESMTP id 54A7EDB57
	for <5570 <at> debbugs.gnu.org>; Sun, 21 Mar 2010 12:50:54 +0100 (CET)
X-SENDER-IP: [85.225.45.110]
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: AlA6AIukpUtV4S1uPGdsb2JhbACbOgwBAQEBNy23doR9BA
X-IronPort-AV: E=Sophos;i="4.51,282,1267398000"; d="scan'208";a="53731659"
Received: from c-6e2de155.25-1-64736c10.cust.bredbandsbolaget.se (HELO
	coolsville.localdomain) ([85.225.45.110])
	by ipb2.telenor.se with ESMTP; 21 Mar 2010 12:50:49 +0100
Received: from [172.20.199.13] (zeplin [172.20.199.13])
	by coolsville.localdomain (Postfix) with ESMTPSA id DD8E17FA01A;
	Sun, 21 Mar 2010 12:50:48 +0100 (CET)
Message-ID: <4BA60814.8080309@HIDDEN>
Date: Sun, 21 Mar 2010 12:50:44 +0100
From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
User-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; sv-SE;
	rv:1.9.1.8) Gecko/20100227 Thunderbird/3.0.3
MIME-Version: 1.0
References: <000301caac36$0fc0b760$2f422620$@net>	<201003182205.12157.pogonyshev@HIDDEN>	<20100319215639.GA2079@HIDDEN>
	<4BA3FE94.7080901@HIDDEN>	<20100320132250.GA2674@HIDDEN>
	<4BA4E063.50704@HIDDEN> <20100321111627.GA2594@HIDDEN>
In-Reply-To: <20100321111627.GA2594@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.1 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.3 (---)



Alan Mackenzie skrev 2010-03-21 12.16:

>
> I'm assuming your Emacs is pretty much the newest bzr version.

Pretty much.

>
> Would you please choose a C file, as small as will work, and start an
> Emacs session with a dribble file (see page "Recording Input" in the
> Elisp manual).  Edit the C file until indentation goes wrong.

It isn't that easy to reproduce, it just sort of happens.
I have no idea if it will happen on a small file.

> Then send
> me the dribble file, the (original) C file, and your CC Mode
> configuration (generated by C-c C-b in the C file).
>

I'll try.

	Jan D.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN:


X-Loop: bug-gnu-emacs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN
Resent-Date: Mon, 22 Mar 2010 08:09:02 +0000
Resent-Message-ID: <handler.5570.B5570.126924531532430 <at> debbugs.gnu.org>
Resent-Sender: bug-gnu-emacs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie <acm@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.126924531532430
          (code B ref 5570); Mon, 22 Mar 2010 08:09:02 +0000
Received: (at 5570) by debbugs.gnu.org; 22 Mar 2010 08:08:35 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1Ntcgc-0008R1-Vh
	for submit <at> debbugs.gnu.org; Mon, 22 Mar 2010 04:08:35 -0400
Received: from smtprelay-h21.telenor.se ([195.54.99.196])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <jan.h.d@HIDDEN>) id 1Ntcgb-0008Qu-2Q
	for 5570 <at> debbugs.gnu.org; Mon, 22 Mar 2010 04:08:33 -0400
Received: from ipb2.telenor.se (ipb2.telenor.se [195.54.127.165])
	by smtprelay-h21.telenor.se (Postfix) with ESMTP id 445D0CA8A
	for <5570 <at> debbugs.gnu.org>; Mon, 22 Mar 2010 09:07:12 +0100 (CET)
X-SENDER-IP: [85.225.45.110]
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Ap1CAHvCpktV4S1uPGdsb2JhbACHXpNMDAEBAQE3LbhjhH0E
X-IronPort-AV: E=Sophos;i="4.51,286,1267398000"; d="scan'208";a="53959609"
Received: from c-6e2de155.25-1-64736c10.cust.bredbandsbolaget.se (HELO
	coolsville.localdomain) ([85.225.45.110])
	by ipb2.telenor.se with ESMTP; 22 Mar 2010 09:07:09 +0100
Received: from [172.20.199.2] (gaffa [172.20.199.2])
	by coolsville.localdomain (Postfix) with ESMTP id BA8DD7FA01A;
	Mon, 22 Mar 2010 09:07:06 +0100 (CET)
Message-ID: <4BA7252A.3080107@HIDDEN>
Date: Mon, 22 Mar 2010 09:07:06 +0100
From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
User-Agent: Thunderbird 2.0.0.24 (X11/20100317)
MIME-Version: 1.0
References: <000301caac36$0fc0b760$2f422620$@net>	<201003182205.12157.pogonyshev@HIDDEN>	<20100319215639.GA2079@HIDDEN>
	<4BA3FE94.7080901@HIDDEN>	<20100320132250.GA2674@HIDDEN>
	<4BA4E063.50704@HIDDEN> <20100321111627.GA2594@HIDDEN>
In-Reply-To: <20100321111627.GA2594@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -3.3 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.3 (---)

Alan Mackenzie skrev:
> Hi, Jan
> 
> 
>>> Does
>>>    M-x (c-state-cache-init)
>>> fix it?
> 
> 
>> No, it does not.
> 

I just got the problem again, while editing gtkutil.c in Emacs.  There
M-: (c-state-cache-init) did indeed fix the problem.

So it sometimes help.  I guess this only adds to the confusion...

	Jan D.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Fri, 02 Apr 2010 17:04:01 +0000
Resent-Message-ID: <handler.5570.B5570.127022779029087 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.127022779029087
          (code B ref 5570); Fri, 02 Apr 2010 17:04:01 +0000
Received: (at 5570) by debbugs.gnu.org; 2 Apr 2010 17:03:10 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NxkGz-0007Z6-W4
	for submit <at> debbugs.gnu.org; Fri, 02 Apr 2010 13:03:10 -0400
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NxkGx-0007Yl-BM
	for 5570 <at> debbugs.gnu.org; Fri, 02 Apr 2010 13:03:08 -0400
Received: (qmail invoked by alias); 02 Apr 2010 17:03:01 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp070) with SMTP; 02 Apr 2010 19:03:01 +0200
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX19iyal6qMNiqb0g0snxoIhuBFl/l+xUT/vmjpCgqW
	q3axk+u56uHl70
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Fri, 2 Apr 2010 20:01:36 +0300
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
References: <000301caac36$0fc0b760$2f422620$@net>
	<20100321111627.GA2594@HIDDEN> <4BA7252A.3080107@HIDDEN>
In-Reply-To: <4BA7252A.3080107@HIDDEN>
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: quoted-printable
Message-Id: <201004022001.37107.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.57999999999999996
X-Spam-Score: 0.4 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.3 (/)

Jan Dj=E4rv wrote:
> Alan Mackenzie skrev:
> >>> Does
> >>>    M-x (c-state-cache-init)
> >>> fix it?
> >=20
> >=20
> >> No, it does not.
> >=20
>=20
> I just got the problem again, while editing gtkutil.c in Emacs.  There
> M-: (c-state-cache-init) did indeed fix the problem.
>=20
> So it sometimes help.  I guess this only adds to the confusion...

I guess that's because there are several similar bugs.  At the rate
fixing goes (or rather doesn't go) I think I'll compile and use an old
Emacs without indentation bugs again.

Paul


P.S.  By the way: maybe this change did fix the original bug, but it
didn't improve overall indentation problems in CC modes noticeably.

2010-03-24  Alan Mackenzie  <acm@HIDDEN>

	* progmodes/cc-engine.el (c-remove-stale-state-cache):
	Fix off-by-one error.  Fixes bug #5747.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
References: <000301caac36$0fc0b760$2f422620$@net>
In-Reply-To: <000301caac36$0fc0b760$2f422620$@net>
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Sat, 03 Apr 2010 23:56:02 +0000
Resent-Message-ID: <handler.5570.B5570.12703389596493 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12703389596493
          (code B ref 5570); Sat, 03 Apr 2010 23:56:02 +0000
Received: (at 5570) by debbugs.gnu.org; 3 Apr 2010 23:55:59 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NyDC3-0001gg-9U
	for submit <at> debbugs.gnu.org; Sat, 03 Apr 2010 19:55:59 -0400
Received: from pantheon-po25.its.yale.edu ([130.132.50.119])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1NyDC1-0001gJ-Pp
	for 5570 <at> debbugs.gnu.org; Sat, 03 Apr 2010 19:55:58 -0400
Received: from furry (173-14-147-246-NewEngland.hfc.comcastbusiness.net
	[173.14.147.246]) (authenticated bits=0)
	by pantheon-po25.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o33Ntrrh013260
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Sat, 3 Apr 2010 19:55:54 -0400
Received: by furry (Postfix, from userid 1000)
	id BCF37C055; Sat,  3 Apr 2010 19:55:53 -0400 (EDT)
From: Chong Yidong <cyd@HIDDEN>
Date: Sat, 03 Apr 2010 19:55:53 -0400
Message-ID: <87pr2gf5va.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -2.9 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.9 (--)

> >>> Does
> >>>    M-x (c-state-cache-init)
> >>> fix it?
> >
> >> No, it does not.
> >
>
> I just got the problem again, while editing gtkutil.c in Emacs.  There
> M-: (c-state-cache-init) did indeed fix the problem.
>
> So it sometimes help.  I guess this only adds to the confusion...

You sent this message on March 22.  That was the date Alan checked this
into the branch:

   2010-03-22  Alan Mackenzie  <acm@HIDDEN>

      * progmodes/cc-engine.el (c-remove-stale-state-cache):
      Fix off-by-one error.  Fixes bug #5747.

The patch was merged to the trunk a couple days later.  I don't know
whether you were running with it when you made the above observation.

So, are you still observing the problem after the patch?




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Sun, 04 Apr 2010 00:16:02 +0000
Resent-Message-ID: <handler.5570.B5570.12703401596932 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.12703401596932
          (code B ref 5570); Sun, 04 Apr 2010 00:16:02 +0000
Received: (at 5570) by debbugs.gnu.org; 4 Apr 2010 00:15:59 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NyDVP-0001nl-3X
	for submit <at> debbugs.gnu.org; Sat, 03 Apr 2010 20:15:59 -0400
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1NyDVM-0001ng-1S
	for 5570 <at> debbugs.gnu.org; Sat, 03 Apr 2010 20:15:57 -0400
Received: (qmail invoked by alias); 04 Apr 2010 00:15:50 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp014) with SMTP; 04 Apr 2010 02:15:50 +0200
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX1+f1IZYDRifwJE6A3jdYJ5Pi2JOytM6BfHSplhZ7t
	Cno+/ZwK4B9tKo
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Sun, 4 Apr 2010 03:14:14 +0300
User-Agent: KMail/1.12.4 (Linux/2.6.29-2-686; KDE/4.3.4; i686; ; )
References: <87pr2gf5va.fsf@HIDDEN>
In-Reply-To: <87pr2gf5va.fsf@HIDDEN>
MIME-Version: 1.0
Message-Id: <201004040314.15065.pogonyshev@HIDDEN>
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: 7bit
X-Y-GMX-Trusted: 0
X-FuHaFi: 0.56000000000000005
X-Spam-Score: 0.5 (/)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -0.2 (/)

Chong Yidong wrote:
> > >>> Does
> > >>>    M-x (c-state-cache-init)
> > >>> fix it?
> > >
> > >> No, it does not.
> > >
> >
> > I just got the problem again, while editing gtkutil.c in Emacs.  There
> > M-: (c-state-cache-init) did indeed fix the problem.
> >
> > So it sometimes help.  I guess this only adds to the confusion...
> 
> You sent this message on March 22.  That was the date Alan checked this
> into the branch:
> 
>    2010-03-22  Alan Mackenzie  <acm@HIDDEN>
> 
>       * progmodes/cc-engine.el (c-remove-stale-state-cache):
>       Fix off-by-one error.  Fixes bug #5747.
> 
> The patch was merged to the trunk a couple days later.  I don't know
> whether you were running with it when you made the above observation.
> 
> So, are you still observing the problem after the patch?

Not directed to me, but I can answer as well.

Yes, I see the problem, though I'm not sure if it is "the" problem,
since there might be many similar ones.

* At least in some cases M-x (c-state-cache-init) doesn't help, but
  C-x RET r (buffer reloading) does;

* Occasionally even buffer reloading doesn't help, so I have to kill
  the buffer and open the file again;

* Sometimes I get wrong indentation which miraculously fixes itself
  after I hit TAB next time;

* Sometimes when I type in a C string (like "bla-bla-bla"), first
  character after the opening quote gets eaten because of a Lisp
  error.  Will report as separate bug when it happens if I don't
  forget.

And yes, I double-verified that I do have the fix in the version I'm
running now.

Paul




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Sun, 04 Apr 2010 08:10:03 +0000
Resent-Message-ID: <handler.5570.B5570.127036857217082 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>
Cc: Alan Mackenzie <acm@HIDDEN>, 5570 <at> debbugs.gnu.org, Paul Pogonyshev <pogonyshev@HIDDEN>
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.127036857217082
          (code B ref 5570); Sun, 04 Apr 2010 08:10:03 +0000
Received: (at 5570) by debbugs.gnu.org; 4 Apr 2010 08:09:32 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1NyKtf-0004RT-SK
	for submit <at> debbugs.gnu.org; Sun, 04 Apr 2010 04:09:32 -0400
Received: from smtprelay-b12.telenor.se ([62.127.194.21])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <jan.h.d@HIDDEN>) id 1NyKtd-0004RM-8e
	for 5570 <at> debbugs.gnu.org; Sun, 04 Apr 2010 04:09:30 -0400
Received: from ipb2.telenor.se (ipb2.telenor.se [195.54.127.165])
	by smtprelay-b12.telenor.se (Postfix) with ESMTP id 9E62BEA52C
	for <5570 <at> debbugs.gnu.org>; Sun,  4 Apr 2010 10:09:25 +0200 (CEST)
X-SENDER-IP: [85.225.45.110]
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: ArAwAHPmt0tV4S1uPGdsb2JhbACHY5NnDAEBAQE1LbBbhQcE
X-IronPort-AV: E=Sophos;i="4.51,361,1267398000"; d="scan'208";a="58821337"
Received: from c-6e2de155.25-1-64736c10.cust.bredbandsbolaget.se (HELO
	coolsville.localdomain) ([85.225.45.110])
	by ipb2.telenor.se with ESMTP; 04 Apr 2010 10:09:25 +0200
Received: from [172.20.199.13] (zeplin [172.20.199.13])
	by coolsville.localdomain (Postfix) with ESMTPSA id 3F5B57FA01A;
	Sun,  4 Apr 2010 10:09:24 +0200 (CEST)
Message-ID: <4BB84935.5090204@HIDDEN>
Date: Sun, 04 Apr 2010 10:09:25 +0200
From: Jan =?UTF-8?Q?Dj=C3=A4rv?= <jan.h.d@HIDDEN>
User-Agent: Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.6; sv-SE;
	rv:1.9.1.9) Gecko/20100317 Thunderbird/3.0.4
MIME-Version: 1.0
References: <87pr2gf5va.fsf@HIDDEN>
In-Reply-To: <87pr2gf5va.fsf@HIDDEN>
Content-Type: text/plain; charset=ISO-8859-1; format=flowed
Content-Transfer-Encoding: 7bit
X-Spam-Score: -3.2 (---)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.2 (---)



Chong Yidong skrev 2010-04-04 01.55:
>>>>> Does
>>>>>     M-x (c-state-cache-init)
>>>>> fix it?
>>>
>>>> No, it does not.
>>>
>>
>> I just got the problem again, while editing gtkutil.c in Emacs.  There
>> M-: (c-state-cache-init) did indeed fix the problem.
>>
>> So it sometimes help.  I guess this only adds to the confusion...
>
> You sent this message on March 22.  That was the date Alan checked this
> into the branch:
>
>     2010-03-22  Alan Mackenzie<acm@HIDDEN>
>
>        * progmodes/cc-engine.el (c-remove-stale-state-cache):
>        Fix off-by-one error.  Fixes bug #5747.
>
> The patch was merged to the trunk a couple days later.  I don't know
> whether you were running with it when you made the above observation

I was running without it.
.
>
> So, are you still observing the problem after the patch?

Yes, but it seems to happen less frequently.  Also, sometimes just another TAB 
at BOL fixes it.

	Jan D.




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
References: <000301caac36$0fc0b760$2f422620$@net>
In-Reply-To: <000301caac36$0fc0b760$2f422620$@net>
Resent-From: Chong Yidong <cyd@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Wed, 28 Apr 2010 18:56:02 +0000
Resent-Message-ID: <handler.5570.B5570.127248094126542 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie  <acm@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.127248094126542
          (code B ref 5570); Wed, 28 Apr 2010 18:56:02 +0000
Received: (at 5570) by debbugs.gnu.org; 28 Apr 2010 18:55:41 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1O7CQ7-0006u3-Uf
	for submit <at> debbugs.gnu.org; Wed, 28 Apr 2010 14:55:40 -0400
Received: from pantheon-po17.its.yale.edu ([130.132.50.73])
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <cyd@HIDDEN>) id 1O7CQ4-0006tv-FO
	for 5570 <at> debbugs.gnu.org; Wed, 28 Apr 2010 14:55:38 -0400
Received: from furry (dhcp128036014104.central.yale.edu [128.36.14.104])
	(authenticated bits=0)
	by pantheon-po17.its.yale.edu (8.12.11.20060308/8.12.11) with ESMTP id
	o3SItYFe008664
	(version=TLSv1/SSLv3 cipher=DHE-RSA-AES256-SHA bits=256 verify=NOT);
	Wed, 28 Apr 2010 14:55:34 -0400
Received: by furry (Postfix, from userid 1000)
	id 6D850C055; Wed, 28 Apr 2010 14:55:34 -0400 (EDT)
From: Chong Yidong <cyd@HIDDEN>
Date: Wed, 28 Apr 2010 14:55:34 -0400
Message-ID: <87eihz5rvd.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
X-YaleITSMailFilter: Version 1.2c (attachment(s) not renamed)
X-Spam-Score: -2.7 (--)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.7 (--)

Hi Alan,

I found a small recipe for reproducing a (the?) cache bug on the trunk:

1. emacs -Q

2. C-x C-f foo.c RET

3. Type the following (from view-lossage):

  i n t SPC m a i n SPC ( ) <return>
  { <return> f o o ; <return> } M-< <return>
  <up> # i n c l u d e SPC < s t d i o . h > <return>
  <down> <down> <down> <tab>

At this point, the line "foo;" becomes indented to the zeroth column.

Does this help?




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Alan Mackenzie <acm@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Thu, 29 Apr 2010 14:56:02 +0000
Resent-Message-ID: <handler.5570.B5570.127255294632327 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Chong Yidong <cyd@HIDDEN>, Paul Pogonyshev <pogonyshev@HIDDEN>
Cc: 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.127255294632327
          (code B ref 5570); Thu, 29 Apr 2010 14:56:02 +0000
Received: (at 5570) by debbugs.gnu.org; 29 Apr 2010 14:55:46 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1O7V9V-0008PM-0v
	for submit <at> debbugs.gnu.org; Thu, 29 Apr 2010 10:55:45 -0400
Received: from colin.muc.de ([193.149.48.1] helo=mail.muc.de)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <acm@HIDDEN>) id 1O7V9S-0008P5-Or
	for 5570 <at> debbugs.gnu.org; Thu, 29 Apr 2010 10:55:43 -0400
Received: (qmail 41860 invoked by uid 3782); 29 Apr 2010 14:55:42 -0000
Received: from acm.muc.de (pD9E238E3.dip.t-dialin.net [217.226.56.227]) by
	colin2.muc.de (tmda-ofmipd) with ESMTP;
	Thu, 29 Apr 2010 16:55:40 +0200
Received: (qmail 15584 invoked by uid 1000); 29 Apr 2010 15:04:42 -0000
Date: Thu, 29 Apr 2010 15:04:42 +0000
Message-ID: <20100429150442.GA4310@HIDDEN>
References: <87eihz5rvd.fsf@HIDDEN>
Mime-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87eihz5rvd.fsf@HIDDEN>
User-Agent: Mutt/1.5.9i
X-Delivery-Agent: TMDA/1.1.5 (Fettercairn)
From: Alan Mackenzie <acm@HIDDEN>
X-Primary-Address: acm@HIDDEN
X-Spam-Score: -1.4 (-)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -2.6 (--)

Hi, Yidong and Paul!

On Wed, Apr 28, 2010 at 02:55:34PM -0400, Chong Yidong wrote:
> Hi Alan,

> I found a small recipe for reproducing a (the?) cache bug on the trunk:

> 1. emacs -Q

> 2. C-x C-f foo.c RET

> 3. Type the following (from view-lossage):

>   i n t SPC m a i n SPC ( ) <return>
>   { <return> f o o ; <return> } M-< <return>
>   <up> # i n c l u d e SPC < s t d i o . h > <return>
>   <down> <down> <down> <tab>

> At this point, the line "foo;" becomes indented to the zeroth column.

> Does this help?

Does it help?  That was an absolute dream of a bug report.  :-)

The problem was another off-by-one error.  What triggered the bug is
typing <return> at the end of the #include line.  The thing marking the
end of the macro (a category text property) got pushed onto the next line
instead of being properly removed.  This then fouled up the
"c-state-cache" mechanism.

It looks like the situation reported by Paul (in his mail of 2010-02-23,
Message-Id: <201002231528.09081.pogonyshev@HIDDEN>) is likely caused by
the same bug.

I've committed a fix to the Bazaar HEAD, which of course is a fix for the
last bug in this area.  ;-)

Paul, would you please update your copy of the Emacs HEAD from savannah,
and see if any indentation bugs still manifest themselves.  Thanks!

-- 
Alan Mackenzie (Nuremberg, Germany).




Message sent to owner <at> debbugs.gnu.org, bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN:


X-Loop: help-debbugs@HIDDEN
Subject: bug#5570: automatic cache validation
Resent-From: Paul Pogonyshev <pogonyshev@HIDDEN>
Original-Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Resent-To: owner <at> debbugs.gnu.org
Resent-CC: bug-gnu-emacs@HIDDEN, bug-cc-mode@HIDDEN
Resent-Date: Sat, 29 May 2010 22:31:02 +0000
Resent-Message-ID: <handler.5570.B5570.127517220620452 <at> debbugs.gnu.org>
Resent-Sender: help-debbugs@HIDDEN
X-GNU-PR-Message: followup 5570
X-GNU-PR-Package: emacs,cc-mode
X-GNU-PR-Keywords: 
To: Alan Mackenzie <acm@HIDDEN>
Cc: Chong Yidong <cyd@HIDDEN>, 5570 <at> debbugs.gnu.org
Received: via spool by 5570-submit <at> debbugs.gnu.org id=B5570.127517220620452
          (code B ref 5570); Sat, 29 May 2010 22:31:02 +0000
Received: (at 5570) by debbugs.gnu.org; 29 May 2010 22:30:06 +0000
Received: from localhost ([127.0.0.1] helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.69)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1OIUXd-0005Jp-EF
	for submit <at> debbugs.gnu.org; Sat, 29 May 2010 18:30:05 -0400
Received: from mail.gmx.net ([213.165.64.20])
	by debbugs.gnu.org with smtp (Exim 4.69)
	(envelope-from <pogonyshev@HIDDEN>) id 1OIUXb-0005JC-E8
	for 5570 <at> debbugs.gnu.org; Sat, 29 May 2010 18:30:04 -0400
Received: (qmail invoked by alias); 29 May 2010 22:29:57 -0000
Received: from unknown (EHLO gonzo.localnet) [91.149.173.2]
	by mail.gmx.net (mp013) with SMTP; 30 May 2010 00:29:57 +0200
X-Authenticated: #16844820
X-Provags-ID: V01U2FsdGVkX18pLPEUSPQpAIIW9CE9gsoFYroSr0K8UmqH9WL5Wi
	ixdiV85lmGP7bg
From: Paul Pogonyshev <pogonyshev@HIDDEN>
Date: Sun, 30 May 2010 01:27:47 +0300
User-Agent: KMail/1.13.3 (Linux/2.6.29-2-686; KDE/4.4.3; i686; ; )
References: <87eihz5rvd.fsf@HIDDEN> <20100429150442.GA4310@HIDDEN>
In-Reply-To: <20100429150442.GA4310@HIDDEN>
MIME-Version: 1.0
Content-Type: Text/Plain;
  charset="iso-8859-1"
Content-Transfer-Encoding: 7bit
Message-Id: <201005300127.47749.pogonyshev@HIDDEN>
X-Y-GMX-Trusted: 0
X-Spam-Score: 1.0 (+)
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.11
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/pipermail/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.5 (/)

Alan Mackenzie wrote:
> Paul, would you please update your copy of the Emacs HEAD from savannah,
> and see if any indentation bugs still manifest themselves.  Thanks!

Yes they do.  I still see all kinds of indentation bugs, none seem to
be gone:

* Sometimes everything is topmost-intro; this may or may not be gone
  after buffer reload with C-x RET r, suggesting at least two sources
  for the bug.

* Indentation sometimes spuriosly changes when hitting TAB (e.g. TAB
  -> to 0th column, TAB again -> to 8th column, TAB third time -> to
  0th once more; no intervening keystrokes).

* Sometimes character after opening " gets eaten see #5851.

I did 'bzr pull', then 'make maintainer-clean && ./configure && make'
and then 'sudo make install'.

Paul





Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.